<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('HOME', '../');
define('PAGE', 'blogs/comments.php');
define('TIME', microtime());

require('../wb-includes/common.php');
require('../wb-includes/plugins/blogs.php');

if (isset($_REQUEST['comment']) && is_unsigned($_REQUEST['comment'], true) && $is_logged) {
	/**
	 * Удаление комментария
	 */
	
	/**
	 * Получение данных комментария
	 */
	$sql = 'select c.comment_id, c.user_id, c.post_id, p.blog_id 
	from ' . BLOG_COMMENTS_TABLE . ' as c 
	inner join ' . BLOG_POSTS_TABLE . ' as p using (post_id) 
	where c.comment_id = ' . $_REQUEST['comment'];
	
	$query = mysql_query($sql);
	$comment_data = mysql_fetch_assoc($query);
	
	if (!$comment_data) {
		redirect('index.php');
	}
	
	do {
		if ($comment_data['blog_id']) {
			if ($user_id == $comment_data['user_id']) {
				break;
			}
			$access = get_blogs_access($blog_id, 'delete_comment');
		} else {
			if ($user_id == $comment_data['user_id']) {
				break;
			}
			$access = get_blog_access('delete_comment');
		}
		
		if ($access['delete_comment']) {
			break;
		}
		
		redirect('comments.php?post=' . $comment_data['post_id']);
	} while (0);
	
	/**
	 * Удаление записи, обновление счетчиков комментариев
	 */
	mysql_query('delete from ' . BLOG_COMMENTS_TABLE . ' where comment_id = ' . $comment_data['comment_id']);
	update_post_count_comments($comment_data['post_id']);
	update_user_count_comments($comment_data['user_id']);
	
	redirect('comments.php?post=' . $comment_data['post_id']);
	
} elseif (isset($_REQUEST['add'], $_REQUEST['post']) && is_unsigned($_REQUEST['post'], true) && $is_logged) {
	/**
	 * Добавление поста
	 */
	$sql = 'select post_id, user_id, blog_id, post_title, privacy_comment
	from ' . BLOG_POSTS_TABLE . ' where post_id = ' . ($post_id = $_REQUEST['post']);
	
	$query = mysql_query($sql);
	$post_data = mysql_fetch_assoc($query);
	
	if (!$post_data) {
		redirect('index.php');
	}
	
	do {
		/**
		 * Комментирование открыто для всех
		 */
		if ($post_data['privacy_comment'] == BLOG_COMMENT_USERS) {
			break;
		}
		
		if ($post_data['privacy_comment'] != BLOG_COMMENT_DISABLE) {
			if ($post_data['blog_id']) {
				/**
				 * Читатель блога
				 */
				if (is_blog_user($post_data['blog_id'], $user_id)) {
					break;
				}
				
				/**
				 * По участию в группах модераторов
				 */
				if (array_sum(get_blogs_access($post_data['blog_id']))) {
					break;
				}
			} else {
				/**
				 * Автор поста
				 */
				if ($user_id == $post_data['user_id']) {
					break;
				}
				
				/**
				 * Проверка по группам модераторов
				 */
				$access = get_blog_access('comment');
				
				if ($access['comment']) {
					break;
				}
				
				if ($post_data['privacy_comment'] == BLOG_COMMENT_FRIENDS && is_friend($user_id, $post_data['user_id'])) {
					break;
				}
				
				if ($post_data['privacy_comment'] == BLOG_COMMENT_F_FRIENDS && (is_friend($user_id, $post_data['user_id']) || is_f_friend($user_id, $post_data['user_id']))) {
					break;
				}
			}
		}
		
		redirect('comments.php?post=' . $post_id);
	} while (0);
	
	$theme = array (
		'Добавление комментария',
		'Добавление комментария',
		'<a href="comments.php?post=' . $post_id . '">К комментариям</a><br />' . "\n" .
		'<a href="post.php?post=' . $post_id . '">К записи</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	/**
	 * Получение данных пользователя, которому отвечают
	 */
	if (isset($_REQUEST['user']) && is_unsigned($_REQUEST['user'])) {
		$sql = 'select user_id, user_login from ' . USERS_TABLE . ' 
		where user_id = ' . $_REQUEST["user"];
		
		$query = mysql_query($sql);
		$_user_data = mysql_fetch_assoc($query);
	} else {
		$_user_data = false;
	}
	
	if (isset($_POST['text'])) {
		$comment = cut($_POST['text'], get_option('length_blog_comment'));
		$comment = check($comment, true);
		
		if (!$comment) {
			redirect('comments.php?add&post=' . $post_id . ($_user_data ? '&user=' . $_user_data['user_id'] : ''));
		}
		
		if ($_user_data) {
			$comment = sprintf(get_option('answer_template'), $_user_data['user_login'], $comment);
		}
		
		if (($wait = antiflood())) {
			$expressions = array('секунду', 'секунды', 'секунд');
			
			echo '<p>' . "\n";
			echo 'Нельзя писать чаще чем раз в ' . get_option('flood_time') . ' ' . declension(get_option('flood_time'), $expressions) . '.<br />' . "\n";
			echo 'Подождите еще ' . $wait . ' ' . declension($wait, $expressions) . ', ';
			echo 'а потом <a href="comments.php?add&post=' . $post_id . ($user ? '&user=' . $_user_data['user_id'] : '') . '">напишите снова</a>' . "\n";
			echo '</p>' . "\n";
			
			close($theme);
		}
		
		$sql = 'insert into ' . BLOG_COMMENTS_TABLE . ' (
		comment_text,
		comment_time,
		post_id,
		user_id
		) values (
		"' . mysql_escape_string($comment) . '",
		' . time() . ',
		' . $post_id . ',
		' . $user_id . '
		)';
		
		mysql_query($sql);
		
		update_antiflood();
		update_post_count_comments($post_id);
		update_user_count_comments($user_id);
		
		redirect('comments.php?post=' . $post_id);
	} else {
		/**
		 * Напоминание об антифлуде
		 */
		if ($wait = antiflood()) {
			echo '<p><span id="info">' . "\n";
			echo 'Действие антифлуда закончится через ' . $wait . ' ' . declension($wait, array('секунду', 'секунды', 'секунд'));
			echo '</span></p>' . "\n";
		}
		
		echo '<form action="comments.php" method="post">' . "\n";
		echo $_user_data ? '<input type="hidden" name="user" value="' . $_user_data['user_id'] . '" />' . "\n" : '';
		echo '<input type="hidden" name="post" value="' . $post_id . '" />' . "\n";
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Добавление комментария к записи "' . $post_data['post_title'] . '"' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Cообщение' . ($_user_data ? ' для <a href="../profile.php?user=' . $_user_data['user_id'] . '">' . $_user_data['user_login'] . '</a>' : '') . ':<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_blog_comment') . ' символов</span><br />' . "\n";
		echo '<textarea name="text" maxlength="' . get_option('length_blog_comment') . '" ' . get_option('textarea_attributes') . '></textarea>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="add" value="Добавить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} elseif (isset($_REQUEST['post']) && is_unsigned($_REQUEST['post'], true)) {
	/**
	 * Проверка переданного Id поста
	 */
	$sql = 'select blog_id, user_id, post_title, privacy_comments, privacy_comment
	from ' . BLOG_POSTS_TABLE . ' where post_id = ' . ($post_id = $_REQUEST['post']);
	
	$query = mysql_query($sql);
	$post_data = mysql_fetch_assoc($query);
	
	if (!$post_data) {
		redirect('index.php');
	}
	
	/**
	 * Просмотр комментариев
	 */
	$theme = array (
			'Комментарии',
			'Комментарии к записи',
			'<a href="post.php?post=' . $post_id . '">К записи</a><br />' . "\n" .
			'<a href="index.php?user=' . $post_data['user_id'] . '">К блогу</a><br />' . "\n" .
			'<a href="../index.php">На главную</a>'
	);
	
	/**
	 * Проверка доступа к комментарием
	 */
	$_access = array('edit_comment' => false, 'delete_comment' => false);
	$allow_comment = $is_logged && $post_data['privacy_comments'] == BLOG_COMMENTS_USERS;
	
	if (($blog_id = $post_data['blog_id'])) {
		/**
		 * Проверка доступа к комментариям записи в коллективном блоге
		 */
		do {
			if ($is_logged) {
				/**
				 * Проверка по группам модераторов
				 */
				$_access = get_blogs_access($blog_id, array('edit_comment', 'delete_comment'));
				
				if ($_access['edit_comment'] || $_access['delete_comment']) {
					$allow_comment = $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE;
					break;
				}
				
				if ($post_data['privacy_comments'] != BLOG_COMMENTS_DISABLE) {
					/**
					 * Проверка по участию в читателях блога
					 */
					if (($post_data['privacy_comments'] == BLOG_COMMENTS_MEMBERS || $post_data['privacy_comment'] == BLOG_COMMENT_MEMBERS) && is_blog_user($blog_id, $user_id)) {
						$allow_comment = $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE;
						break;
					}
				} elseif ($user_id == $post_data['user_id'] && is_blog_user($blog_id, $user_id)) {
					break;
				}
			}
			
			switch ($post_data['privacy_comments']) {
				case BLOG_COMMENTS_USERS:
					break 2;
				
				case BLOG_COMMENTS_DISABLE:
					echo '<p>Комментирование закрыто</p>' . "\n";
					break;
				
				default:
					echo '<p>Просмотр комментариев этой записи доступен только читателям блога</p>' . "\n";
					break;
			}
			
			close($theme);
		} while (0);
	} else {
		/**
		 * Проверка доступа к комментариям записи в личном блоге
		 */
		do {
			if ($is_logged) {
				/**
				* Проверка по участию в группах модраторов
				*/
				$_access = get_blog_access(array('view_comments', 'edit_comment', 'delete_comment', 'comment'));
				
				if ($_access['view_comments']) {
					/**
					 * Если есть полномочие к комментированию или комментарии открыты для всех,
					 * иначе - проверяем по авторству и спискам друзей
					 */
					if ($_access['comment'] || $allow_comment) {
						$allow_comment = true;
						break;
					}
					
					/**
					 * Доступ к просмотру есть, комментарии закрыты,
					 * продолжать проверки бессмысленно
					 */
					if ($post_data['privacy_comment'] == BLOG_COMMENT_DISABLE) {
						break;
					}
				}
				
				/**
				 * Автор имеет доступ к комментариям
				 */
				if ($user_id == $post_data['user_id']) {
					$allow_comment = $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE;
					break;
				}
				
				if ($post_data['privacy_comment'] != BLOG_COMMENTS_DISABLE) {
					/**
					 * Проверка по спискам друзей,
					 */
					if ($post_data['privacy_comments'] == BLOG_COMMENTS_FRIENDS && is_friend($user_id, $post_data['user_id'])) {
						$allow_comment = $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE; /** Если комментирование не выключено */
						break;
					} elseif ($post_data['privacy_comments'] == BLOG_COMMENTS_F_FRIENDS && (is_friend($user_id, $post_data['user_id']) || is_f_friend($user_id, $post_data['user_id']))) {
						$allow_comment = $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE || $post_data['privacy_comment'] == BLOG_COMMENT_FRIENDS; /** Если комментирование не выключено и не для друзей */
						break;
					}
				}
			}
			
			/**
			 * Просмотр записи для всех пользователей
			 */
			if ($post_data['privacy_comment'] == BLOG_COMMENTS_USERS) {
				break;
			}
			
			echo '<p>' . "\n";
			echo 'Доступ к просмотру комментариев закрыт владельцем блога' . "\n";
			echo '</p>' . "\n";
		} while (0);
	}
	
	$sql = 'select count(*) 
	from ' . BLOG_COMMENTS_TABLE . ' where post_id = ' . $post_id;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_comments());
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Комментарии к записи "' . $post_data['post_title'] . '"' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$sql = 'select c.*, u.user_login 
		from ' . BLOG_COMMENTS_TABLE . ' as c 
		left join ' . USERS_TABLE . ' as u using (user_id) 
		where c.post_id = ' . $post_id . ' order by c.comment_id desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<a href="../profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
			
			if ($allow_comment) {
				echo '<a href="comments.php?add&amp;post=' . $post_id . '&amp;user=' . $fields['user_id'] . '">[отв]</a> ';
			}
			
			switch (is_online($fields['user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '(' . fdate($fields['comment_time']) . ')<br />' . "\n";
			echo tags($fields['comment_text']) . '<br />' . "\n";
			
			if ($_access['delete_comment'] || ($is_logged && $user_id == $fields['user_id'])) {
				echo '<a href="comments.php?delete&amp;comment=' . $fields['comment_id'] . '">Удалить</a>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего комментариев: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'comments.php?post=' . $post_id . '&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Комментариев нет' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($allow_comment) {
		echo '<p>' . "\n";
		echo '<a href="comments.php?add&amp;post=' . $post_id . '">Добавить комментарий</a>' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST['user']) && is_unsigned($_REQUEST['user'], true)) {
	
	$sql = 'select user_login 
	from users where user_id = ' . ($user = $_REQUEST['user']);
	
	$login = @mysql_result(mysql_query($sql), 0);
	$login or redirect('index.php');
	
	$theme = array (
		'Комментарии',
		'Комментарии пользователя',
		'<a href="../profile.php?user=' . $user . '">К профилю</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = 'select count(*) 
	from ' . BLOG_COMMENTS_TABLE . ' where user_id = ' . $user;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_comments());
		
		$sql = 'select c.*, p.post_id, p.post_title, p.post_count_comments, b.blog_id, b.blog_name, u.user_login
		from ' . BLOG_COMMENTS_TABLE . ' as c
		inner join ' . BLOG_POSTS_TABLE . ' as p on (p.post_id = c.post_id) 
		left join ' . BLOGS_TABLE . ' as b on (b.blog_id = p.blog_id) 
		left join ' . USERS_TABLE . ' as u on (u.user_id = p.user_id) 
		where c.user_id = ' . $user . ' order by c.comment_id desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Комментарии пользователя ' . $login . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			
			if ($fields['blog_id']) {
				echo 'Блог <a href="index.php?blog=' . $fields['blog_id'] . '">' . $fields['blog_name'] . '</a> &rarr; ';
			} else {
				echo 'Блог им. <a href="index.php?user=' . $fields['user_id'] . '">' . $fields['user_login']  . '</a> &rarr; ';
			}
			
			echo '<a href="post.php?post=' . $fields['post_id'] . '">' . $fields['post_title'] . '</a> / ';
			echo '<span style="color:red">' . $fields['post_count_comments'] . '</span> / ' . "\n";
			echo fdate($fields['comment_time']) . '<br />' . "\n";
			echo tags($fields['comment_text']) . '' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего комментариев: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'comments.php?user=' . $user . '&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Комментариев нет' . "\n";
		echo '</p>' . "\n";
	}
} else {
	redirect('index.php');
}

close($theme);
?>