<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('HOME', '../');
define('PAGE', 'blogs/editpost.php');
define('TIME', microtime());

require('../wb-includes/common.php');
require('../wb-includes/plugins/blogs.php');

if (!$is_logged || empty($_REQUEST['post']) || !is_unsigned($_REQUEST['post'], true)) {
	redirect('index.php');
}


$sql = 'select p.*, b.blog_name 
from ' . BLOG_POSTS_TABLE . ' as p 
left join ' . BLOGS_TABLE . ' as b using (blog_id) 
where post_id = ' . ($post_id = $_REQUEST['post']);
	
$query = mysql_query($sql);
$post_data = mysql_fetch_assoc($query);

if (!$post_data) {
	redirect('index.php');
}

$blog_id = $post_data['blog_id'];
$blog_name = $post_data['blog_name'];

/**
 * Для редактирования сообщения есть два варианта доступа:
 * 1) Авторство поста и участие в читателях группы (если коллективный блог);
 * 2) Полномочия для редактирования (участие в группах модераторов).
 */
do {
	if ($user_id == $post_data['user_id'] && (!$blog_id || is_blog_user($blog_id, $user_id))) {
		break;
	}
	
	if ($blog_id) {
		$access = get_blogs_access($blog_id, 'edit_post');
	} else {
		$access = get_blog_access('edit_post');
	}
	
	if (!$access['edit_post']) {
		redirect('post.php?post=' . $post_id);
	}
} while (false);


if (isset($_POST['move'], $_POST['blog']) && is_unsigned($_POST['blog'])) {
	
	if ($_POST['blog'] > 0) {
		$sql = 'select b.blog_id 
		from ' . BLOGS_USER_TABLE . ' as u 
		inner join ' . BLOGS_TABLE . ' as b using (blog_id) 
		where u.blog_id = ' . $_POST['blog'] . ' and u.user_id = ' . $user_id . ' and u.is_entry = "0"';
		
		$query = mysql_query($sql);
		$blog_id = @mysql_result($query, 0);
	} else {
		$blog_id = 0;
	}
	
	$sql = 'update ' . BLOG_POSTS_TABLE . ' set 
	blog_id = ' . $blog_id . ',
	privacy_post = "' . BLOG_POST_USERS . '", 
	privacy_comment = "' . BLOG_COMMENT_USERS . '", 
	privacy_comments = "' . BLOG_COMMENTS_USERS . '"
	where post_id = ' . $post_id;
	
	mysql_query($sql);
	redirect('editpost.php?post=' . $post_id);
	
} elseif (isset($_POST['title'], $_POST['text'], $_POST['tags'])) {
	$text = cut($_POST['text'], get_option('length_blog_post'));
	$text = mysql_escape_string(check($text, true));
	
	$title = cut($_POST['title'], get_option('length_blog_post_title'));
	$title = mysql_escape_string(check($title));
	
	$count = 0;
	$tags = array();
	
	if (($t_tags = preg_split('/[\s]*[,][\s]*/', check($_POST['tags'])))) {
		foreach ($t_tags as $tag) {
			if (preg_match('/^[A-zА-я\d\s\-_]+$/u', $tag) && mb_strlen($tag) <= get_option('length_blog_tag')) {
				$tags[] = $tag;
			}
			
			if (++$count >= get_option('quota_blog_tags')) {
				break;
			}
		}
	}
	
	if ($blog_id) {
		$privacy_post = BLOG_POST_MEMBERS;
		$privacy_comments = BLOG_COMMENTS_MEMBERS;
		$privacy_comment = BLOG_COMMENT_MEMBERS;
		
		if ((isset($_POST['privacy_post']) && $_POST['privacy_post'] == BLOG_POST_USERS)) {
			$privacy_post = BLOG_POST_USERS;
		}
		
		if (isset($_POST['privacy_comments']) && ($_POST['privacy_comments'] == BLOG_COMMENTS_DISABLE || $_POST['privacy_comments'] == BLOG_COMMENTS_USERS)) {
			$privacy_comments = $_POST["privacy_comments"];
		}
		
		if (isset($_POST['privacy_comment']) && ($_POST['privacy_comment'] == BLOG_COMMENT_DISABLE || $_POST['privacy_comment'] == BLOG_COMMENT_USERS)) {
			$privacy_comment = $_POST['privacy_comment'];
		}
		
		if ($privacy_post == BLOG_POST_MEMBERS && $post_data['privacy_comments'] != BLOG_COMMENTS_DISABLE) {
			$privacy_comments = BLOG_COMMENTS_MEMBERS;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_DISABLE) {
			$privacy_comment = BLOG_COMMENT_DISABLE;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_MEMBERS && $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE) {
			$privacy_comment = BLOG_COMMENT_MEMBERS;
		}
	} else {
		$privacy_post = BLOG_POST_USERS;
		$privacy_comments = BLOG_COMMENTS_USERS;
		$privacy_comment = BLOG_COMMENT_USERS;
		
		if (isset($_POST['privacy_post']) && ($_POST['privacy_post'] == BLOG_POST_FRIENDS || $_POST['privacy_post'] == BLOG_POST_F_FRIENDS)) {
			$privacy_post = $_POST['privacy_post'];
		}
		
		if (isset($_POST['privacy_comments']) && ($_POST['privacy_comments'] == BLOG_COMMENTS_DISABLE || $_POST['privacy_comments'] == BLOG_COMMENTS_FRIENDS || $_POST['privacy_comments'] == BLOG_COMMENTS_F_FRIENDS)) {
			$privacy_comments = $_POST["privacy_comments"];
		}
		
		if (isset($_POST['privacy_comment']) && ($_POST['privacy_comment'] == BLOG_COMMENT_DISABLE || $_POST['privacy_comment'] == BLOG_COMMENT_FRIENDS || $_POST['privacy_comment'] == BLOG_COMMENT_F_FRIENDS)) {
			$privacy_comment = $_POST['privacy_comment'];
		}
		
		if ($privacy_post == BLOG_POST_FRIENDS && $post_data['privacy_comments'] != BLOG_COMMENTS_DISABLE) {
			$privacy_comments = BLOG_COMMENTS_FRIENDS;
		}
		
		if ($privacy_post == BLOG_POST_F_FRIENDS && $post_data['privacy_comments'] != BLOG_COMMENTS_DISABLE && $post_data['privacy_comments'] != BLOG_COMMENTS_FRIENDS) {
			$privacy_comments = BLOG_COMMENTS_F_FRIENDS;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_DISABLE) {
			$privacy_comment = BLOG_COMMENT_DISABLE;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_FRIENDS && $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE) {
			$privacy_comment = BLOG_COMMENT_FRIENDS;
		}
		
		if ($privacy_comments == BLOG_COMMENTS_F_FRIENDS && $post_data['privacy_comment'] != BLOG_COMMENT_DISABLE && $post_data['privacy_comment'] != BLOG_COMMENT_FRIENDS) {
			$privacy_comment = BLOG_COMMENT_F_FRIENDS;
		}
	}
	
	if ($title && $text && count($tags)) {
		mysql_query('update ' . BLOG_POSTS_TABLE . ' set 
		post_title = "' . $title . '",
		post_text = "' . $text . '",
		post_edit_time = ' . time() . ',
		post_edit_user_id = ' . $user_id . ',
		privacy_post = "' . $privacy_post . '",
		privacy_comments = "' . $privacy_comments . '",
		privacy_comment = "' . $privacy_comment . '" 
		where post_id = ' . $post_id);
		
		update_post_tags($post_id, $tags);
		?>
<p>
Запись изменена<br />
<a href="post.php?post=<?php echo $post_id ?>">Посмотреть на запись</a><br />
<a href="editpost.php?post=<?php echo $post_id ?>">Изменить снова</a>
</p>
<?php } else { ?>
<p>
Вы не ввели тему, сообщение или метку.<br />
<a href="editpost.php?post=<?php echo $post_id ?>">Назад</a>
</p>
<?php
	}
} else {
	// Составляет массив информации о блогах, для вставки в select
	$sql = 'select b.blog_id, b.blog_name 
	from ' . BLOGS_USER_TABLE . ' as u 
	inner join ' . BLOGS_TABLE . ' as b using (blog_id) 
	where u.user_id = ' . $user_id . ' and u.is_entry = "0"';
	
	$query = mysql_query($sql);
	
	$blogs[] = array (
		'blog_id' => 0,
		'blog_name' => 'Личный блог'
	);
	
	while ($row = mysql_fetch_assoc($query)) {
		$blogs[] = $row;
	}
?>
<form action="editpost.php" method="post">
<input type="hidden" name="post" value="<?php echo $post_id ?>" />
<table <?php echo get_option('table_attributes') ?>>
<tr>
<td id="title">
Редактор записи
</td>
</tr>

<tr>
<td id="text">
Выберите блог:<br />
<select name="blog">
<?php foreach ($blogs as $row) { ?>
<option value="<?php echo $row['blog_id'] ?>"<?php $row['blog_id'] == $blog_id and print(' selected="selected"') ?>><?php echo $row['blog_name'] ?></option>
<?php } ?>
</select>
</td>
</tr>
<tr>
<td id="text">
Тема:<br />
<span id="info">Не более <?php echo get_option('length_blog_post_title') ?> символов</span><br />
<input type="text" name="title" size="40" maxlength="<?php echo get_option('length_blog_post_title') ?>" value="<?php echo $post_data['post_title']  ?>" />
</td>
</tr>

<tr>
<td id="text">
Сообщение:<br />
<span id="info">Не более <?php echo get_option('length_blog_post') ?> символов</span><br />
<textarea name="text" maxlength="<?php echo get_option('length_blog_post') ?>" <?php echo get_option('textarea_attributes') ?>><?php echo $post_data['post_text']  ?></textarea>
</td>
</tr>

<tr>
<td id="text">
Метки:<br />
<span id="info">Не более <?php echo get_option('quota_blog_tags') ?> <?php echo declension(get_option('quota_blog_tags'), array('метка', 'меток')) ?>. Метки нужно разделять запятой</span><br />
<input type="text" name="tags" size="40" value="<?php echo $post_data['post_tags'] ?>" />
</td>
</tr>


<?php if ($blog_id) { ?>
<tr>
<td id="text">
Кто может просматривать эту запись:<br />
<input type="radio" name="privacy_post" value="<?php echo BLOG_POST_MEMBERS ?>" <?php $post_data['privacy_post'] == BLOG_POST_MEMBERS and print('checked="checked"' )?>/> Читатели блога<br />
<input type="radio" name="privacy_post" value="<?php echo BLOG_POST_USERS ?>" <?php $post_data['privacy_post'] == BLOG_POST_USERS and print('checked="checked"' )?> /> Все пользователи
</td>
</tr>

<tr>
<td id="text">
Кто может просматривать комментарии к этой записи:<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_DISABLE ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_DISABLE and print('checked="checked"' )?>/> Выключить обсуждение<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_MEMBERS ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_MEMBERS and print('checked="checked"' )?>/> Читатели блога<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_USERS ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_USERS and print('checked="checked"' )?>/> Все пользователи
</td>
</tr>

<tr>
<td id="text">
Кто может может комментировать эту запись:<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_DISABLE ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_DISABLE and print('checked="checked"' ) ?>/> Выключить обсуждение<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_MEMBERS ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_MEMBERS and print('checked="checked"' ) ?>/> Читатели блога<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_USERS ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_USERS and print('checked="checked"' ) ?>/> Все пользователи
</td>
</tr>
<?php } else { ?>
<tr>
<td id="text">
Кто может просматривать эту запись:<br />
<input type="radio" name="privacy_post" value="<?php echo BLOG_POST_FRIENDS ?>" <?php $post_data['privacy_post'] == BLOG_POST_FRIENDS and print('checked="checked"' ) ?>/> Только мои друзья<br />
<input type="radio" name="privacy_post" value="<?php echo BLOG_POST_F_FRIENDS ?>" <?php $post_data['privacy_post'] == BLOG_POST_F_FRIENDS and print('checked="checked"' ) ?>/> Мои друзья и друзья друзей<br />
<input type="radio" name="privacy_post" value="<?php echo BLOG_POST_USERS ?>" <?php $post_data['privacy_post'] == BLOG_POST_USERS and print('checked="checked"' ) ?>/> Все пользователи
</td>
</tr>

<tr>
<td id="text">
Кто может просматривать комментарии к этой записи:<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_DISABLE ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_DISABLE and print('checked="checked"' ) ?>/> Выключить обсуждение<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_FRIENDS ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_FRIENDS and print('checked="checked"' ) ?>/> Только мои друзья<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_F_FRIENDS ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_F_FRIENDS and print('checked="checked"' ) ?>/> Мои друзья и друзья друзей<br />
<input type="radio" name="privacy_comments" value="<?php echo BLOG_COMMENTS_USERS ?>" <?php $post_data['privacy_comments'] == BLOG_COMMENTS_USERS and print('checked="checked"' ) ?>/> Все пользователи
</td>
</tr>

<tr>
<td id="text">
Кто может может комментировать эту запись:<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_DISABLE ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_DISABLE and print('checked="checked"' ) ?>/> Выключить обсуждение<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_FRIENDS ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_FRIENDS and print('checked="checked"' ) ?>/> Только мои друзья<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_F_FRIENDS ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_F_FRIENDS and print('checked="checked"' ) ?>/> Мои друзья и друзья друзей<br />
<input type="radio" name="privacy_comment" value="<?php echo BLOG_COMMENT_USERS ?>" <?php $post_data['privacy_comment'] == BLOG_COMMENT_USERS and print('checked="checked"' ) ?>/> Все пользователи
</td>
</tr>
<?php } ?>

<tr>
<td id="sub">
<input type="submit" name="save" value="Изменить" /> 
<input type="submit" name="move" value="Перенести в другой блог" />
</td>
</tr>

</table>
</form>
<?php
}

close(
	'Редактирование записи', 
	'Редактирование записи', 
	'<a href="post.php?post=' . $post_id . '">К записи</a><br />' . "\n" . 
	'<a href="index.php">К блогам</a><br />' . "\n" . 
	'<a href="../index.php">На главную</a>'
);
?>