<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('ONLY_LOGGED', 1);
define('PAGE', 'friends.php');
define('TIME', microtime());

require('wb-includes/common.php');
require('wb-includes/plugins/friends.php');

if (isset($_GET['add'], $_GET['user']) && is_unsigned($_GET['user'], true) && $_GET['user'] != $user_id) {
	/**
	 * Добавление пользователя в список друзей
	 */
	
	$theme = array (
		'Друзья',
		'Добавление пользователя в друзья',
		'<a href="friends.php">Друзья</a><br />' . "\n" . 
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select user_id, user_friendship_privacy 
	from ' . USERS_TABLE . ' where user_id = ' . $_GET['user'];
	
	$query = mysql_query($sql);
	$fields = mysql_fetch_assoc($query);
	
	if (!$fields || $fields['user_friendship_privacy'] == FRIENDSHIP_DISABLE) {
		redirect('index.php');
	}
	
	switch ($fields['user_friendship_privacy']) {
		case FRIENDSHIP_USERS_WITH_ENTRY:
			$sql = 'insert into ' . FRIENDS_ENTRIES_TABLE . ' values (
			' . $fields['user_id'] . ',
			' . $user_id . '
			)';
			
			mysql_query($sql);
         
			echo '<p>' . "\n";
			echo 'Пользователю отправлена заявка на добавление Вас в список друзей<br />' . "\n";
			echo '<a href="profile.php?user=' . $fields['user_id'] . '">К профилю</a>' . "\n";
			echo '</p>' . "\n";
			break;
		
		case FRIENDSHIP_USERS:
			$sql = 'insert into ' . FRIENDS_TABLE . ' values (
			' . $fields['user_id'] . ',
			' . $user_id . '
			), (
			' . $user_id . ',
			' . $fields['user_id'] . '
			)';
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Пользователь добавлен в список друзей<br />' . "\n";
			echo '<a href="profile.php?user=' . $fields['user_id'] . '">К профилю</a>' . "\n";
			echo '</p>' . "\n";
	}
} elseif (isset($_POST['users']) && is_array($_POST['users'])) {
	/**
	 * Удаление / одобрение друзей
	 */
	
	$users = array();
	
	foreach ($_POST['users'] as $id) {
		if (is_unsigned($id, true)) {
			$users[] = $id;
		}
	}
	
	if (!count($users)) {
		redirect('friends.php');
	}
	
	$sql = 'select user_id from ' . USERS_TABLE . ' 
	where user_id in (' . implode(', ', array_unique($users)) . ')';
	
	$users = array();
	$query = mysql_query($sql);
	
	while ($row = mysql_fetch_row($query)) {
		$users[] = $row[0];
	}
	
	if (!count($users)) {
		redirect('friends.php');
	}
	
	$users_str = implode(', ', $users);
	
	if (isset($_POST['delete'])) {
		if (isset($_POST['entries'])) {
			$sql = 'delete from ' . FRIENDS_ENTRIES_TABLE . '
			user_id = ' . $user_id . ' and friend_user_id in (' . $users_str . ')';
			
			mysql_query($sql);
			redirect('friends.php?entries');
		} else {
			$sql = 'delete from ' . FRIENDS_TABLE . '
			where (
			user_id = ' . $user_id . ' and friend_user_id in (' . $users_str . ')) or (
			friend_user_id = ' . $user_id . ' and user_id in (' . $users_str . '))';
			
			mysql_query($sql);
			redirect('friends.php');
		}
	} else {
		foreach ($users as $id) {
			// т.к. на поля user_id & friend_user_id стоит unique index,
			// то можно без дополнительных проверок делать insert'ы в таблицу
			$sql = 'insert into ' . FRIENDS_TABLE . ' values (
			' . $user_id . ',
			' . $id . '
			), (
			' . $id . ',
			' . $user_id . '
			)';
			
			mysql_query($sql);
		}
		
		$sql = 'delete from ' . FRIENDS_ENTRIES_TABLE . '
		where user_id = ' . $user_id . ' and friend_user_id in (' . $users_str . ')';
		
		mysql_query($sql);
		redirect('friends.php?entries');
	}
} elseif (isset($_GET['entries'])) {
	/**
	 * Предложения дружбы
	 */
	
	$theme = array (
		'Друзья',
		'Предложения дружбы',
		'<a href="friends.php">Назад</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select f.friend_user_id as user_id, u.user_login 
	from ' . FRIENDS_ENTRIES_TABLE . ' as f 
	inner join ' . USERS_TABLE . ' as u on (u.user_id = f.friend_user_id) 
	where f.user_id = ' . $user_id;
	
	$query = mysql_query($sql);
	
	if (mysql_num_rows($query)) {
		echo '<form action="friends.php" method="post">' . "\n";
		echo '<input type="hidden" name="entries" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Предложения дружбы' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="checkbox" name="users[]" value="' . $fields['user_id'] . '" /> ';
			echo '<a href="profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
			
			switch (is_online($fields['user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="approve" value="Одобрить" /> ' . "\n";
		echo '<input type="submit" name="delete" value="Удалить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo 'Нет друзей' . "\n";
		echo '</p>' . "\n";
	}
} else {
	/**
	 * Просмотр списка друзей
	 */
	
	if (isset($_REQUEST['user']) && is_unsigned($_REQUEST['user'], true) && $_REQUEST['user'] != $user_id) {	
		/**
		 * Проверка существования пользователя, приватности отображения друзей
		 */
		$sql = 'select user_id, user_friends_privacy 
		from '. USERS_TABLE . ' where user_id = ' . $_REQUEST['user'];
		
		$query = mysql_query($sql);
		$fields = mysql_fetch_assoc($query);
		
		if ($fields) {
			$owner_id = $fields['user_id'];
			
			do {
				/**
				 * Для всех
				 */
				if ($fields['user_friends_privacy'] == FRIENDS_USERS) {
					break;
				}
				
				/**
				 * Для друзей
				 */
				if ($fields['user_friends_privacy'] == FRIENDS_FRIENDS || $fields['user_friends_privacy'] == FRIENDS_F_FRIENDS) {
					if (is_friend($user_id, $owner_id)) {
						break;
					}
				}
				
				/**
				 * Для друзей или друзей друзей
				 */
				if ($fields['user_friends_privacy'] == FRIENDS_F_FRIENDS && is_f_friend($user_id, $owner_id)) {
					break;
				}
				
				$theme = array (
					'Друзья',
					'Друзья',
					'<a href="profile.php?user=' . $owner_id . '">К профилю</a><br />' . "\n" .
					'<a href="index.php">На главную</a>'
				);
				
				/**
				 * Доступа нет
				 */
				echo '<p>' . "\n";
				echo 'Вы не можете просматривать друзей этого пользователя' . "\n";
				echo '</p>' . "\n";
				
				close($theme);
			}
			while (0);
		} else {
			redirect('index.php');
		}
	} else {
		$owner_id = $user_id;
	}
	
	$theme = array (
		'Друзья',
		'Друзья',
		'<a href="index.php">На главную</a>'
	);
	
	
	$sql = 'select count(*) 
	from ' . FRIENDS_TABLE . ' where user_id = ' . $owner_id;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		if ($user_id == $owner_id) {
			echo '<form action="friends.php" method="post">' . "\n";
			echo '<input type="hidden" name="friends" />' . "\n";
		}
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Друзья' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$sql = 'select f.friend_user_id as user_id, u.user_login 
		from ' . FRIENDS_TABLE . ' as f 
		inner join ' . USERS_TABLE  . ' as u on (u.user_id = f.friend_user_id) 
		where f.user_id = ' . $owner_id . ' 
		order by u.user_login 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			
			if ($user_id == $owner_id) {
				echo '<input type="checkbox" name="users[]" value="' . $fields['user_id'] . '" /> ';
			}
			
			echo '<a href="profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
			
			if ($user_id == $owner_id) {
				echo '<a href="privmsgs.php?write&amp;user=' . $fields['user_id'] . '">[лс]</a> ';
			}
			
			switch (is_online($fields['user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		if ($pagination['all_pages'] > 1) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Всего друзей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'friends.php?user=' . $owner_id . '&amp;page=%d') . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		if ($user_id == $owner_id) {
			echo '<tr>' . "\n";
			echo '<td id="sub">' . "\n";
			echo '<input type="submit" name="delete" value="Удалить" />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($user_id == $owner_id) {
			echo '</form>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Друзей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($user_id == $owner_id) {
		$sql = 'select count(*) 
		from ' . FRIENDS_ENTRIES_TABLE . ' where user_id = ' . $user_id;
		
		$query = mysql_query($sql);
		$count = mysql_result($query, 0);
		
		if ($count) {
			echo '<p>' . "\n";
			echo '<a href="friends.php?entries">Предложения дружбы (' . $count . ')</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo '<a href="profile.php?user=' . $owner_id . '">К профилю</a>' . "\n";
		echo '</p>' . "\n";
	}
}

close($theme);
?>