<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("PAGE", "groups.php");
define("TIME", microtime());

require("wb-includes/common.php");

if (isset($_REQUEST["group"]) && is_unsigned($_REQUEST["group"], true)) {
	/**
	 * Просмотр информации о группе, участниуков группы
	 */
	
	$sql = "select * from " . GROUPS_TABLE . " 
	where group_id = " . ($group_id = $_REQUEST["group"]);
	
	$query = mysql_query($sql);
	$fields = mysql_fetch_assoc($query);
	
	if (!$fields) {
		redirect("groups.php");
	}
	
	$theme = array (
		'Группа "' . $fields["group_name"] . '"',
		'Группа "' . $fields["group_name"] . '"',
		'<a href="groups.php">Назад</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Информация о группе' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Название:<br />' . "\n";
	echo $fields['group_name'] . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if ($fields['group_description']) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Описание:<br />' . "\n";
		echo $fields['group_description'] . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Группа создана:<br />' . "\n";
	echo fdate($fields['group_add_time']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	
	/**
	 * Участники группы
	 */
	$sql = "select g.user_id, u.user_login from " . GROUP_USER_TABLE . " as g
	inner join " . USERS_TABLE . " as u using (user_id)
	where g.group_id = " . $group_id;
	
	$query = mysql_query($sql);
	
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Участники группы' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if (mysql_num_rows($query)) {
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<a href="profile.php?user=' . $fields["user_id"] . '">' . $fields["user_login"] . '</a> ';
			
			switch (is_online($fields['user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
	} else {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Нет участников' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
	
	if ($is_admin) {
		echo '<p>' . "\n";
		echo '<a href="wb-admin/admin_groups.php?edit&amp;group=' . $group_id . '">Изменить данные группы</a>' . "\n";
		echo '</p>' . "\n";
	}
} else {
	/**
	 * Список групп
	 */
	
	$theme = array (
		'Группы',
		'Группы',
		'<a href="index.php">На главную</a>'
	);
	
	$groups = array();
	
	/**
	 * Участие в группах
	 */
	if ($is_logged) {
		$sql = "select group_id 
		from " . GROUP_USER_TABLE . " where user_id = " . $user_id;
		
		$query = mysql_query($sql);
		
		while ($row = mysql_fetch_row($query)) {
			$groups[] = $row[0];
		}
		
		if (count($groups)) {
			echo '<table ' . get_option('table_attributes') . '>' . "\n";
			echo '<tr>' . "\n";
			echo '<td id="title">' . "\n";
			echo 'Участие в группах' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			
			$sql = "select group_id, group_name from " . GROUPS_TABLE . "
			where group_id in (" . implode(", ", $groups) . ")";
			
			$query = mysql_query($sql);
			
			while ($fields = mysql_fetch_assoc($query)) {
				echo '<tr>' . "\n";
				echo '<td id="text">' . "\n";
				echo '<a href="groups.php?group=' . $fields["group_id"] . '">' . $fields["group_name"] . '</a>' . "\n";
				echo '</td>' . "\n";
				echo '</tr>' . "\n";
			}
			
			echo '</table>' . "\n";
		}
	}
	
	/**
	 * Все группы
	 */
	if (count($groups)) {
		$sql = "select group_id, group_name from " . GROUPS_TABLE . " 
		where group_id not in (" . implode(", ", $groups) . ")";
	} else {
		$sql = "select group_id, group_name from " . GROUPS_TABLE;
	}
	
	$query = mysql_query($sql);
	
	if (mysql_num_rows($query)) {
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Группы' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<a href="groups.php?group=' . $fields["group_id"] . '">' . $fields["group_name"] . '</a>' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
	}
	
	if ($is_admin) {
		echo '<p>' . "\n";
		echo '<a href="wb-admin/admin_groups.php">Администирование</a>' . "\n";
		echo '</p>' . "\n";
	}
}

close($theme);
?>