<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("PAGE", "index.php");
define("TIME", microtime());

require("wb-includes/common.php");
require("wb-includes/plugins/cache.php");
require("wb-includes/plugins/blogs.php");

echo '<table ' . get_option('table_attributes') . '>' . "\n";

if (!$is_logged) {
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Вход:' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Добро пожаловать, гость!<br />' . "\n";
	echo 'Для пользования всеми сервисами сайта ';
	echo '<a href="login.php">войдите</a> или сперва ' . "\n";
	echo '<a href="register.php">зарегистрируйтесь</a>!' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
} else {
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Личное меню:' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Добро пожаловать, ' . $user_data["user_" . ($user_data["user_name"] ? "name" : "login")] . '!<br />' . "\n";
	echo '<a href="usercp.php">Кабинет</a>, ';
	echo '<a href="blogs/">Блоги</a>, ' . "\n";
	echo '<a href="friends.php">Друзья</a>, ' . "\n";
	echo '<a href="wall.php">Стена</a>, ' . "\n";
	echo '<a href="groups.php">Группы</a>, ' . "\n";
	echo '<a href="users.php">Пользователи</a>, ' . "\n";
	echo '<a href="index.php?logout">Выход</a>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

echo '</table>' . "\n";

/**
 * Отображение последних десяти записей в коллективных блогах
 */

$sql = 'select p.*, b.blog_name
from  ' . BLOG_POSTS_TABLE . ' as p 
inner join ' . BLOGS_TABLE . ' as b using (blog_id) 
where p.blog_id <> 0 
order by p.post_add_time desc 
limit 10';

$query = mysql_query($sql);

if (mysql_num_rows($query)) {
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo '<a href="blogs/">Все</a>  &rarr; Последние записи в коллективных блогах:' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	while ($post_data = mysql_fetch_assoc($query)) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		
		echo 'Блог <a href="blogs/index.php?blog=' . $post_data['blog_id'] . '">' . $post_data['blog_name'] . '</a> &rarr; <br />' . "\n";
		echo '<a href="blogs/post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . ' </a> от ' . fdate($post_data['post_add_time']) . '<br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
}

/**
 * Прямой эфир
 */
$sql = 'select 
u1.user_id as author_user_id, 
u2.user_login as author_user_login, 
p.post_id, p.blog_id, p.user_id as author_user_id, p.post_title, p.post_count_comments, 
u2.user_id, u2.user_login, 
b.blog_name 
from ' . BLOG_COMMENTS_TABLE . ' as c 
inner join ' . BLOG_POSTS_TABLE . ' as p on (p.post_id = c.post_id) 
left join ' . BLOGS_TABLE . ' as b on (b.blog_id = p.blog_id) 
inner join ' . USERS_TABLE . ' as u1 on (u1.user_id = c.user_id) 
left join ' . USERS_TABLE . ' as u2 on (u2.user_id = p.user_id) 
group by p.post_id
order by c.comment_id desc
limit 10';

$query = mysql_query($sql);

if (mysql_num_rows($query)) {
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Прямой эфир:' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	while ($data = mysql_fetch_assoc($query)) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<a href="profile.php?user=' . $data['author_user_id'] . '">' . $data['author_user_login'] . '</a> &rarr; ' . "\n";
		
		if ($data['blog_id']) {
			echo 'Блог <a href="blogs/index.php?blog=' . $data['blog_id'] . '">' . $data['blog_name'] . '</a> / ';
		} else {
			echo 'Блог им. <a href="profile.php?user=' . $data['user_id'] . '">' . $data['user_login']  . '</a> / ';
		}
		
		echo '<a href="blogs/post.php?post=' . $data['post_id'] . '"> ' . $data['post_title'] . '</a>' . "\n";
		echo '<span style="color:red">' . $data['post_count_comments'] . '</span>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
}

/**
 * Популярные метки
 */
$sql = 'select count(*) from ' . BLOG_TAGS_TABLE;
$count = mysql_result(mysql_query($sql), 0);

if ($count) {
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo '<a href="blogs/tag.php">Все</a> &rarr; Популярные метки:' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";

	// Смотрите wb-includes/plugins/blogs.php
	foreach (get_popular_tags(30, true, 14, 25) as $tag) {
		echo '<a href="blogs/tag.php?tag=' . urlencode($tag['tag']) . '" style="font-size:' . $tag['size'] . 'px">' . $tag['tag'] . /*'(' . $tag['count'] . ')' .*/ '</a> ';
	}

	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
}

/**
 * Отображение 10 активных блоггеров
 */
$sql = 'select user_id, user_login, user_count_posts from ' . USERS_TABLE . ' 
where user_count_posts > 0 order by user_count_posts desc limit 10';

$query = mysql_query($sql);

if (mysql_num_rows($query)) {
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo '<a href="users.php?users&amp;mode=user_count_posts&amp;order=desc">Все</a>  &rarr; Самые активные блоггеры:' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	while ($data = mysql_fetch_assoc($query)) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<a href="profile.php?user=' . $data['user_id'] . '">' . $data['user_login'] . '</a> &rarr; ' . "\n";
		echo $data['user_count_posts'] . ' ' . declension($data['user_count_posts'], array('запись', 'записи', 'записей')) . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
}


close("Главная страница", get_option("home_title"));
?>