<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('PAGE', 'login.php');
define('TIME', microtime());

require('wb-includes/common.php');

if ($is_logged) {
	redirect('index.php');
}

$l = isset($_REQUEST['l']) ? $_REQUEST['l'] : '';
$l = preg_match('/^[A-z0-9\-_]+$/', $l) ? $l : '';

$p = isset($_REQUEST['p']) ? $_REQUEST['p'] : '';
$p = preg_match('/^[A-z0-9]+$/', $p) ? $p : '';

$id = isset($_REQUEST['id']) ? $_REQUEST['id'] : '';
$id = is_unsigned($id) ? $id : '';

$redirect = isset($_REQUEST['redirect']) ? $_REQUEST['redirect'] : '';
$redirect = preg_match('[^a-z0-9\./]', '', $redirect);

if (($l || $id) && $p) {
	$sql = 'select * from ' . USERS_TABLE . ' 
	where ' . ($id ? 'user_id = ' . $id : 'user_login = "' . $l . '"');
	
	$query = mysql_query($sql);
	$user_data = mysql_fetch_assoc($query);
	
	if (!$user_data) {
		$theme = array (
			'Авторизация',
			'Авторизация',
			'<a href="login.php">К форме авторизации</a><br />' . "\n" . 
			'<a href="index.php">На главную</a>'
		);
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Авторизация' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Авторизация не удалась<br />' . "\n";
		echo 'Пользователь с ' . ($id ? 'ID ' . $id : 'логином "' . $l . '"') . ' не зарегистрирован!<br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
	} elseif ($user_data['user_password'] != md5(md5($p))) {
		$theme = array (
			'Авторизация',
			'Авторизация',
			'<a href="login.php">К форме авторизации</a><br />' . "\n" . 
			'<a href="index.php">На главную</a>'
		);
		
		unset($user_data);
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Авторизация' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Авторизация не удалась!<br />' . "\n";
		echo 'Пароль не верен!<br />' . "\n";
		echo '<a href="login.php">К форме авторизации</a>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
	} else {
		$theme = array (
			'Авторизация',
			'Авторизация',
			'<a href="index.php">На главную</a>'
		);
		
		$is_logged = true;
		$user_id = $user_data['user_id'];
		$is_admin = $user_data['user_admin_privilege'];
		
		$cookies = array (
			$user_data['user_id'],
			$user_data['user_password']
		);
		
		setcookie('cookies_data', base64_encode(serialize($cookies)), time() + 31536000);
		
		$_SESSION['user_id'] = $user_data['user_id'];
		$_SESSION['user_pass'] = $user_data['user_password'];
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Авторизация' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Вы успешно авторизовались!<br />' . "\n";
		echo 'Возможно использование ссылки для автовхода:<br />' . "\n";
		echo '<input type="text" value="' . get_option('http_home_url') . '/login.php?l=' . $l . '&amp;p=' . $p . '" />' . "\n";
		echo '</td>' . "\n";
		
		if ($redirect) {
			echo '<td id="text">' . "\n";
			echo '<a href="' . $redirect . '">Перейти на страницу</a>' . "\n";
			echo '</td>' . "\n";
		}
		
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
	}
} else {
	$theme = array (
		'Авторизация',
		'Авторизация',
		'<a href="index.php">На главную</a>'
	);
	
	echo '<form action="login.php?next" method="post">' . "\n";
	echo '<input type="hidden" name="redirect" value="' . $redirect . '" />' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Авторизация' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Логин:<br />' . "\n";
	echo '<input type="text" name="l" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Пароль:<br />' . "\n";
	echo '<input type="password" name="p" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo '<input type="checkbox" name="cookie" value="1" checked="checked" /> Запомнить меня<br />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" value="Авторизация" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close($theme);
?>