<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('ONLY_LOGGED', 1);
define('PAGE', 'wall.php');
define('TIME', microtime());

require('wb-includes/common.php');
require('wb-includes/plugins/friends.php');

/**
 * Проверка существования указанного пользователя, приватности просмотра стены
 */
if (isset($_REQUEST['user']) && is_unsigned($_REQUEST['user'], true) && $user_id != $_REQUEST['user']) {
	$sql = 'select user_id, user_wall_privacy, user_wall_posting_privacy 
	from ' . USERS_TABLE . ' where user_id = ' . $_REQUEST['user'];
	
	$query = mysql_query($sql);
	$fields = mysql_fetch_assoc($query);
	
	if ($fields) {
		$owner_id = $fields['user_id'];
		
		/**
		 * Проверка приватности просмотра стены
		 */
		do {
			if ($is_admin) {
				break;
			}
			
			/**
			 * Для друзей
			 */
			if ($fields['user_wall_privacy'] == WALL_FRIENDS || $fields['user_wall_privacy'] ==  WALL_F_FRIENDS) {
				if (($is_friend = is_friend($user_id, $owner_id))) {
					break;
				}
				
				/**
				 * Для друзей друзей
				 */
				if ($fields['user_wall_privacy'] == WALL_F_FRIENDS && ($is_f_friend = is_f_friend($user_id, $owner_id))) {
					break;
				}
			}
			
			/**
			 * Если приватность - "для всех", но параметры $is_friends или $is_f_friend понадобятся для 
			 * добавления сообщения, проверяем их сейчас
			 */
			if ($fields['user_wall_privacy'] == WALL_USERS && ($fields['user_wall_posting_privacy'] == WALL_POSTING_FRIENDS || $fields['user_wall_posting_privacy'] == WALL_POSTING_F_FRIENDS)) {
				$is_friend = is_friend($user_id, $owner_id);
				
				if (!$is_friend && $fields['user_wall_posting_privacy'] == WALL_POSTING_F_FRIENDS) {
					$is_f_friend = is_f_friend($user_id, $owner_id);
				}
				
				break;
			}
			
			/**
			 * Нельзя
			 */
			echo '<p>' . "\n";
			echo 'Доступ к просмотру стены закрыт пользователем' . "\n";
			echo '</p>' . "\n";
			
			close('Стена', 'Стена', '<a href="index.php">На главную</a>');
		}
		while(0);
		
		/**
		 * Проверка доступа к написанию сообщения
		 */
		do {
			$allow_posting = true;
			
			if ($is_admin) {
				break;
			}
			
			/**
			 * Для всех
			 */
			if ($fields['user_wall_posting_privacy'] == WALL_POSTING_USERS) {
				break;
			}
			
			/**
			 * Для друзей
			 */
			if ($fields['user_wall_posting_privacy'] == WALL_POSTING_FRIENDS && $is_friend) {
				break;
			}
			
			/**
			 * Для друзей или друзей друзей
			 */
			if ($fields['user_wall_posting_privacy'] == WALL_POSTING_F_FRIENDS && ($is_friend || $is_f_freind)) {
				break;
			}
			
			$allow_posting = false;
		}
		while (0);
	} else {
		redirect('index.php');
	}
} else {
	$owner_id = $user_id;
	$allow_posting = true;
}

if (isset($_REQUEST['clear'])) {
	/**
	 * Чистка стены
	 */
	
	if (!$is_admin && $user_id != $owner_id) {
		redirect('wall.php?user=' . $user_id);
	}
	
	$theme = array (
		'Стена',
		'Чистка стены',
		'<a href="wall.php?user=' . $owner_id . '">К стене</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	
	if (isset($_POST['period'], $_POST['time'])) {
		$time = 60*60*24;
		
		switch ($_POST['period']) {
			case 'day':
				break;
			
			case 'week':
				$time *= 7;
				break;
			
			case 'month':
				$time *= 30;
				break;
			
			case 'my':
				$time = (int) $_POST['time'] * 3600;
				break;
			
			default:
				$time = 0;
		}
		
		$sql = 'delete from ' . WALL_POSTS_TABLE . ' 
		where owner_user_id = ' . $owner_id . ' and time < ' . (time() - $time);
		
		mysql_query($sql);
		
		echo '<p>' . "\n";
		echo 'Стена очищена!' . "\n";
		echo '</p>' . "\n";
	} else {
		echo '<form action="wall.php" method="post">' . "\n";
		echo '<input type="hidden" name="clear" />' . "\n";
		echo '<input type="hidden" name="user" value="' . $owner_id . '" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Чистка стены' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Удалить сообщения:<br />' . "\n";
		echo '<input type="radio" name="period" value="all" checked="checked" /> Все<br />' . "\n";
		echo '<input type="radio" name="period" value="day" /> Старше 1 дня<br />' . "\n";
		echo '<input type="radio" name="period" value="week" /> Старше 1 недели<br />' . "\n";
		echo '<input type="radio" name="period" value="month" /> Старше 1 месяца' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<input type="radio" name="period" value="my" /> Другое значение (в часах):<br />' . "\n";
		echo '<input type="text" name="time" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" value="Очистить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} elseif (isset($_GET['add']) && $allow_posting) {
	/**
	 * Добавление соообщения
	 */
	
	$theme = array (
		'Стена',
		'Добавление сообщения',
		'<a href="wall.php?user=' . $owner_id . '">К стене</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$user = false;
	
	if (isset($_REQUEST['id']) && is_unsigned($_REQUEST['id'], true)) {
		$sql = 'select user_id, user_login from ' . USERS_TABLE . ' 
		where user_id = ' . $_REQUEST['id'];
		
		$query = mysql_query($sql);
		$user = mysql_fetch_assoc($query);
	}
	
	if (isset($_POST['content'])) {
		/**
		 * Формирование сообщения
		 */
		$text = cut($_POST['content'], get_option('length_wall_message'));
		$text = check($text, true);
		
		if ($user) {
			$text = sprintf(get_option('answer_template'), $user['user_login'], $text);
		}
		
		$text = mysql_escape_string($text);
		
		/**
		 * Антифлуд
		 */
		if (($wait = antiflood())) {
			$expressions = array('секунду', 'секунды', 'секунд');
			
			echo '<p>' . "\n";
			echo 'Нельзя писать чаще чем раз в ' . get_option('flood_time') . ' ' . declension(get_option('flood_time'), $expressions) . '.<br />' . "\n";
			echo 'Подождите еще ' . $wait . ' ' . declension($wait, $expressions) . ', а потом <a href="wall.php?add&amp;user=' . $owner_id . '">напишите снова</a>' . "\n";
			echo '</p>' . "\n";
			
			close($theme);
		}
		
		$sql = 'insert into ' . WALL_POSTS_TABLE . ' (
		user_id,
		post_user_id,
		post_text,
		post_add_time
		) values (
		' . $owner_id . ',
		' . $user_id . ',
		"' . mysql_escape_string($text) . '",
		' . time() . '
		)';
		
		mysql_query($sql);
		update_antiflood();
		
		redirect('wall.php?user=' . $owner_id);
	} else {
		/**
		 * Антифлуд
		 */
		if (($wait = antiflood())) {
			echo '<p><span id="info">' . "\n";
			echo 'Действие антифлуда закончится через ' . $wait . ' ' . declension($wait, array('секунду', 'секунды', 'секунд'));
			echo '</span></p>' . "\n";
		}
		
		echo '<form action="wall.php?add&amp;user=' . $owner_id . '" method="post">' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Отправка сообщения' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo $user ? '<input type="hidden" name="id" value="' . $user['user_id'] . '" />' . "\n" : '';
		echo 'Cообщение' . ($user ? ' для <a href="profile.php?user=' . $user['user_id'] . '">' . $user['user_login'] . '</a>' : '') . ':<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_wall_message') . ' символов</span><br />' . "\n";
		echo '<textarea name="content" maxlength="' . get_option('length_wall_message') . '" ' . get_option('textarea_attributes') . '></textarea>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>';
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" value="Добавить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} elseif (isset($_GET['delete'], $_GET['post']) && is_unsigned($_GET['post'], true)) {
	/**
	 * Удаление сообщений
	 */
	$sql = 'select user_id, post_user_id 
	from ' . WALL_POSTS_TABLE . ' where wall_id = ' . ($wall_id = $_GET['post']);
	
	$query = mysql_query($sql);
	$fields = mysql_fetch_row($query);
	
	if ($fields) {
		/**
		 * Администратор может удалять все сообщения,
		 * Владелец стены - только напсианные на его стене,
		 * Автор сообщения - только свои сообщения
		 */
		if ($is_admin ||$fields["user_id"] == $user_id || $fields["post_user_id"] == $user_id) {
			$sql = 'delete from ' . WALL_POSTS_TABLE . ' where wall_id = ' . $wall_id;
			mysql_query($sql);
		}
		
		redirect('wall.php?user=' . $fields["user_id"]);
	} else {
		redirect('index.php');
	}
} else {
	/**
	 * Просмотр содержимого стены
	 */
	
	$theme = array (
		'Стена',
		'Стена',
		'<a href="profile.php?user=' . $owner_id . '">К профилю</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select count(*) 
	from ' . WALL_POSTS_TABLE . ' where user_id = ' . $owner_id;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Стена' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$sql = 'select w.*, u.user_login 
		from ' . WALL_POSTS_TABLE . ' as w 
		left join ' . USERS_TABLE . ' as u on (u.user_id = w.post_user_id) 
		where w.user_id = ' . $owner_id . ' order by w.wall_id desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<a href="profile.php?user=' . $fields['post_user_id'] . '">' . $fields['user_login'] . '</a> ';
			echo '<a href="wall.php?add&amp;user=' . $owner_id . '&amp;id=' . $fields['post_user_id'] . '">[отв]</a> ';
			
			switch (is_online($fields['post_user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '(' . fdate($fields['post_add_time']) . ')<br />' . "\n";
			echo tags($fields['post_text']) . '<br />' . "\n";
			
			if ($user_id == $owner_id || $user_id == $fields['post_user_id'] || $is_admin) {
				echo '<a href="wall.php?delete&amp;post=' . $fields['wall_id'] . '">Удалить</a>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего сообщений: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'wall.php?' . ($owner_id ? 'user=' . $owner_id . '&amp;' : '') . 'page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Сообщений нет' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($allow_posting) {
		echo '<p>' . "\n";
		echo '<a href="wall.php?add&amp;user=' . $owner_id . '">Добавить сообщение</a>' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($user_id  == $owner_id || $is_admin) {
		echo '<p>' . "\n";
		echo '<a href="wall.php?clear&amp;user=' . $owner_id . '">Чистка стены</a>' . "\n";
		echo '</p>' . "\n";
	}
}

close($theme);
?>