<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("ONLY_ADMINS", 1);
define("HOME", "../");
define("PAGE", "admin_blog_access.php");
define("TIME", microtime());

require("../wb-includes/common.php");

/**
 * Удаление записей с несуществующими группами
 */

mysql_query("delete from " . BLOG_ACCESS_TABLE . " 
where group_id <> 0 and group_id not in (select group_id from " . GROUPS_TABLE  . ")");

if (isset($_POST["save"])) {
	/**
	 * Изменение / удаление 
	 */
	
	$theme = array (
		'Админ-панель',
		'Редактирование прав доступа групп к личным блогам',
		'<a href="admin_blog_access.php">Назад</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	if (isset($_POST["array"]) && is_array($_POST["array"])) {
		$array = $_POST["array"];
		$array_delete = array('group' => array(), 'user' => array());
		
		foreach ($array as $type => $sub_array) {
			// type: user or group
			$type = $type == 'groups' ? 'group' : 'user';
			
			/**
			 * Пробегаемся по массиву, обновляем записи к которым есть параметры;
			 * составляем список групп для последующего удаления.
			 */
			foreach ($sub_array as $id => $access) {
				if (is_unsigned($id, true)) {
					$allow_view_post = (int) isset($access["view_post"]);
					$allow_edit_post = (int) isset($access["edit_post"]);
					$allow_delete_post = (int) isset($access["delete_post"]);
					$allow_view_comments = (int) isset($access["view_comments"]);
					$allow_edit_comment = (int) isset($access["edit_comment"]);
					$allow_delete_comment = (int) isset($access["delete_comment"]);
					$allow_comment = (int) isset($access["comment"]);
					
					if ($allow_view_post || $allow_edit_post || $allow_delete_post || $allow_view_comments || $allow_edit_comment || $allow_delete_comment || $allow_comment) {
						/**
						 * Обновление записи
						 */
						$sql = "update " . BLOG_ACCESS_TABLE . " set 
						allow_view_post = '" . $allow_view_post . "',
						allow_edit_post = '" . $allow_edit_post . "',
						allow_delete_post = '" . $allow_delete_post . "',
						allow_view_comments = '" . $allow_view_comments . "',
						allow_edit_comment = '" . $allow_edit_comment . "',
						allow_delete_comment = '" . $allow_delete_comment . "',
						allow_comment = '" . $allow_comment . "'
						where " . $type . "_id = " . $id;
						
						mysql_query($sql);
					} else {
						$array_delete[$type][] = $id;
					}
				}
				
				
			}
		}
		
		/**
		 * Удаление групп/юзеров
		 */
		if (count($array_delete['group']) && count($array_delete['user'])) {
			$sql = "delete from " . BLOG_ACCESS_TABLE . " where 
			group_id in (" . implode(", ", $array_delete['group']) . ") or 
			user_id in (" . implode(", ", $array_delete['user']) . ")";
			
			mysql_query($sql);
		} elseif (count($array_delete['group'])) {
			$sql = "delete from " . BLOG_ACCESS_TABLE . " where 
			group_id in (" . implode(", ", $array_delete['group']) . ")";
			
			mysql_query($sql);
		} elseif (count($array_delete['user'])) {
			$sql = "delete from " . BLOG_ACCESS_TABLE . " where 
			user_id in (" . implode(", ", $array_delete['user']) . ")";
			
			mysql_query($sql);
		}
	}
	
	echo '<p>' . "\n";
	echo 'Права доступа изменены' . "\n";
	echo '</p>' . "\n";
} elseif (isset($_REQUEST["add"])) {
	/**
	 * Форма для добавления параметров для группы
	 */
	
	$theme = array (
		'Админ-панель',
		'Добавление прав доступа группы',
		'<a href="admin_blog_access.php">Назад</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	if (isset($_POST["group"], $_POST["user"])) {
		if (is_unsigned($_POST["group"], true)) {
			$sql = "select group_id 
			from " . GROUPS_TABLE . " where group_id = " . $_POST["group"];
			
			$id = @mysql_result(mysql_query($sql), 0);
			$type = 'group';
			
			$id or redirect('admin_blog_access.php?blog=' . $blog_id);
		} else {
			$sql = 'select user_id from ' . USERS_TABLE . ' 
			where ' . (is_unsigned($_POST['user'], true) ? 'user_id' : 'user_login')  . ' = "' . mysql_escape_string(check($_POST['user'])) . '"';
			
			$id = @mysql_result(mysql_query($sql), 0);
			$type = 'user';
			
			$id or redirect('admin_blog_access.php?blog=' . $blog_id);
		}
		
		$allow_view_post = (int) isset($_POST["view_post"]);
		$allow_edit_post = (int) isset($_POST["edit_post"]);
		$allow_delete_post = (int) isset($_POST["delete_post"]);
		$allow_view_comments = (int) isset($_POST["view_comments"]);
		$allow_edit_comment = (int) isset($_POST["edit_comment"]);
		$allow_delete_comment = (int) isset($_POST["delete_comment"]);
		$allow_comment = (int) isset($_POST["comment"]);
		
		if ($allow_view_post || $allow_edit_post || $allow_delete_post || $allow_view_comments || $allow_edit_comment || $allow_delete_comment || $allow_comment) {
			$sql = "insert into " . BLOG_ACCESS_TABLE . " (
			user_id,
			group_id,
			allow_view_post,
			allow_edit_post,
			allow_delete_post,
			allow_view_comments,
			allow_edit_comment,
			allow_delete_comment,
			allow_comment
			) values (
			" . ($type == 'user' ? $id : "NULL") . ",
			" . ($type == 'group' ? $id : "NULL") . ",
			'" . $allow_view_post . "',
			'" . $allow_edit_post . "',
			'" . $allow_delete_post . "',
			'" . $allow_view_comments . "',
			'" . $allow_edit_comment . "',
			'" . $allow_delete_comment . "',
			'" . $allow_comment . "'
			)";
			echo $sql;
			mysql_query($sql);echo mysql_Error();
			
			echo '<p>' . "\n";
			echo 'Права доступа для ' . ($type == 'user' ? 'указанного пользователя' : 'указанной группы') .  ' добавлены<br />' . "\n";
			echo '<a href="admin_blog_access.php?add">Добавить еще</a>' . "\n";
			echo '</p>' . "\n";
		} else {
			echo '<p>' . "\n";
			echo 'Не указаны права доступа<br />' . "\n";
			echo '<a href="admin_blog_access.php?add">Назад</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		$sql = "select group_id, group_name from " . GROUPS_TABLE . " 
		where group_id not in (select group_id from " . BLOG_ACCESS_TABLE . ")";
		
		$query = mysql_query($sql);
		
		echo '<form action="admin_blog_access.php" method="post">' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Добавление прав доступа' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Группы..<br />' . "\n";
		echo '<select name="group">' . "\n";
		echo '<option value="0">Выберите</option>' . "\n";
		
		while ($rows = mysql_fetch_row($query)) {
			echo '<option value="' . $rows[0] . '">' . $rows[1] . '</option>' . "\n";
		}
		
		echo '</select>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '.. или пользователя:<br />' . "\n";
		echo '<input type="text" name="user" value="" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Права:<br />' . "\n";
		echo '<input type="checkbox" name="view_post" value="1" /> Просмотр всех постов<br />' . "\n";
		echo '<input type="checkbox" name="edit_post" value="1" /> Редактирование постов<br />' . "\n";
		echo '<input type="checkbox" name="delete_post" value="1" /> Удаление поста<br />' . "\n";
		echo '<input type="checkbox" name="view_comments" value="1" /> Просмотр комментариев<br />' . "\n";
		echo '<input type="checkbox" name="edit_comment" value="1" /> Редактирование комментариев<br />' . "\n";
		echo '<input type="checkbox" name="delete_comment" value="1" /> Удаление комментариев<br />' . "\n";
		echo '<input type="checkbox" name="comment" value="1" /> Добавление комментария' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="add" value="Добавить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} else {
	/**
	 * Редактирование прав доступа
	 */
	$theme = array (
		'Админ-панель',
		'Редактирование прав доступа групп к личным блогам',
		'<a href="index.php">Админ-панель</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = 'select a.*, g.group_name 
	from ' . BLOG_ACCESS_TABLE . ' as a 
	inner join ' . GROUPS_TABLE . ' as g using (group_id)
	where a.group_id <> 0';
	
	$query = mysql_query($sql);
	
	echo '<form action="admin_blog_access.php" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";	
	
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Редактирование прав доступа групп к личным блогам' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if (mysql_num_rows($query)) {
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="hidden" name="array[groups][' . $fields['group_id'] . ']" />' . "\n";
			echo 'Название группы: ' . "\n";
			echo '<a href="../groups.php?group=' . $fields['group_id'] . '">' . $fields['group_name'] . '</a><br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][view_post]" value="1" ' . ($fields['allow_view_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
			echo 'Просмотр всех постов<br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][edit_post]" value="1" ' . ($fields['allow_edit_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
			echo 'Редактирование постов<br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][delete_post]" value="1" ' . ($fields['allow_delete_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
			echo 'Удаление поста<br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][edit_comment]" value="1" ' . ($fields['allow_edit_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Редактирование комментариев<br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][view_comments]" value="1" ' . ($fields['allow_view_comments'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Просмотр комментариев<br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][delete_comment]" value="1" ' . ($fields['allow_delete_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Удаление комментариев<br />' . "\n";
			echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][comment]" value="1" ' . ($fields['allow_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Добавление комментария<br />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
	} else {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Групп нет';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	/**
	 * Получение параметров для всех пользователей, модерирующих блоги
	 */
	$sql = 'select a.*, u.user_login 
	from ' . BLOG_ACCESS_TABLE . ' as a
	inner join ' . USERS_TABLE . ' as u using (user_id) 
	where a.user_id <> 0';
	
	$query = mysql_query($sql);
	
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Редактирование прав доступа пользователей к личным блогам' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if (mysql_num_rows($query)) {
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="hidden" name="array[users][' . $fields['user_id'] . ']" />' . "\n";
			echo 'Пользователь: ' . "\n";
			echo '<a href="../profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a><br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][view_post]" value="1" ' . ($fields['allow_view_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
			echo 'Просмотр всех постов<br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][edit_post]" value="1" ' . ($fields['allow_edit_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
			echo 'Редактирование постов<br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][delete_post]" value="1" ' . ($fields['allow_delete_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
			echo 'Удаление поста<br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][edit_comment]" value="1" ' . ($fields['allow_edit_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Редактирование комментариев<br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][view_comments]" value="1" ' . ($fields['allow_view_comments'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Просмотр комментариев<br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][delete_comment]" value="1" ' . ($fields['allow_delete_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Удаление комментариев<br />' . "\n";
			echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][comment]" value="1" ' . ($fields['allow_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
			echo 'Добавление комментария<br />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
	} else {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Таких пользователей нет' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" name="save" value="Изменить" />' . "\n";
	echo '<input type="submit" name="add" value="Добавить &gt;" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close($theme);
?>