<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("ONLY_ADMINS", 1);
define("HOME", "../");
define("PAGE", "admin_blogs.php");
define("TIME", microtime());

require("../wb-includes/common.php");

/**
 * Передан Id блога?
 */
$blog_id = 0;
$blog_data = array();

if (isset($_REQUEST['blog']) && is_unsigned($_REQUEST['blog'], true)) {
	$sql = 'select blog_id, blog_type, blog_name, blog_description from ' . BLOGS_TABLE . ' 
	where blog_id = ' . ($blog_id = $_REQUEST['blog']);

	$query = mysql_query($sql);
	$blog_data = mysql_fetch_assoc($query);
}

if (isset($_REQUEST["moderators"]) && $blog_data) {
	/**
	 * Редирект на страницу редактирования прав групп
	 */
	redirect("admin_blogs_access.php?blog=" . $blog_id);
	
} elseif (isset($_POST["delete"]) && $blog_data) {
	/**
	 * Удаление блога, участников блога
	 */
	mysql_query('delete from ' . BLOGS_TABLE . ' where blog_id = ' . $blog_id);
	mysql_query('delete from ' . BLOGS_USER_TABLE . ' where blog_id = ' . $blog_id);
	
	/**
	 * Удаление комментариев
	 */
	mysql_query('delete from ' . BLOG_COMMENTS_TABLE . ' where post id in (
	select post_id from ' . BLOG_POSTS_TABLE . ' where blog_id = ' . $blog_id . ')');
	
	/**
	 * Удаление постов
	 */
	mysql_query('delete from ' . BLOG_POSTS_TABLE . ' where blog_id = ' . $blog_id . ')');
	redirect('admin_blogs.php');
	
} elseif (isset($_POST["save"])) {
	/**
	 * Сохранение изменений
	 */
	
	$theme = array (
		'Админ-панель',
		'Сохранение данных блога',
		'<a href="admin_blogs.php">Блоги</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$name = $description = '';
	$type = BLOG_OPEN;
	
	if (isset($_POST['name'])) {
		$name = cut(check($_POST['name']), get_option('length_blog_name'));
		$name = mysql_escape_string($name);
	}
	
	if (isset($_POST['description'])) {
		$description = cut(check($_POST['description'], true), get_option('length_blog_description'));
		$description = mysql_escape_string($description);
	}
	
	if (isset($_POST['type'])) {
		$type = $_POST['type'] == BLOG_ENTRY || $_POST['type'] == BLOG_CLOSE ? $_POST['type'] : $type;
	}
	
	if ($name) {
		if ($blog_data) {
			$sql = 'update ' . BLOGS_TABLE . ' set 
			blog_name = "' . $name . '",
			blog_type = "' . $type . '",
			blog_description = "' . $description . '"
			where blog_id = ' . $blog_id;
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Данные блога изменены<br />' . "\n";
			echo '<a href="admin_blogs.php?edit&amp;blog=' . $blog_id . '">Назад</a>' . "\n";
			echo '</p>' . "\n";
		} else {
			$sql = 'insert into ' . BLOGS_TABLE . ' (
			blog_type,
			blog_name,
			blog_description,
			blog_add_time
			) values (
			"' . $type . '",
			"' . $name . '",
			"' . $description . '",
			"' . time() . '"
			)';
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Блог создан<br />' . "\n";
			echo '<a href="admin_blogs.php?create">Создать еще</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Не введено имя!<br />' . "\n";
		echo '<a href="admin_blogs.php' . ($blog_data ? '?edit&amp;blog=' . $blog_id : '') . '">Назад</a>' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST["create"]) || isset($_REQUEST["edit"])) {
	/**
	 * Форма для добавления / редактирования Блоги
	 */
	
	$theme = array (
		'Админ-панель',
		$blog_data ? 'Редактирование блога' : 'Создание блога',
		'<a href="admin_blogs.php">Блоги</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	echo '<form action="admin_blogs.php?' . ($blog_data ? 'blog=' . $blog_id : '') . '" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo ($blog_data ? 'Редактирование блога' : 'Создание блога') . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Название блога:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('length_group_name') . ' символов</span><br />' . "\n";
	echo '<input type="text" name="name" maxlength="' . get_option('length_blog_name')  . '" value="' . ($blog_data ? $blog_data["blog_name"] : '') . '" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Описание блога:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('length_group_description') . ' символов</span><br />' . "\n";
	echo '<textarea name="description" maxlength="' . get_option('length_blog_description')  . '" ' . get_option('textarea_attributes') . '>' . ($blog_data ? $blog_data["blog_description"] : '') . '</textarea>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Вступление в читателей блога:<br />' . "\n";
	echo '<input type="radio" name="type" value="' . BLOG_OPEN .'"' . ($blog_data && $blog_data["blog_type"] == BLOG_OPEN ? ' checked="checked"' : '') . ' /> Открыто<br />' . "\n";
	echo '<input type="radio" name="type" value="' . BLOG_ENTRY .'"' . ($blog_data && $blog_data["blog_type"] == BLOG_ENTRY ? ' checked="checked"' : '') . ' /> C предмодерацией<br />' . "\n";
	echo '<input type="radio" name="type" value="' . BLOG_CLOSE .'"' . ($blog_data && $blog_data["blog_type"] == BLOG_CLOSE ? ' checked="checked"' : '') . ' /> Закрыто' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" name="save" value="' . ($blog_data ? 'Изменить блог' : 'Создать блог') . '" /> ' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
} else {
	/**
	 * Выбор коллективного блога
	 */
	
	$theme = array (
		'Админ-панель',
		'Управление коллективными блогами',
		'<a href="index.php">Админ-панель</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = "select blog_id, blog_name from " . BLOGS_TABLE;
	$query = mysql_query($sql);
	
	echo '<form action="admin_blogs.php" method="post">' . "\n";
	echo '<table ' . get_option("table_attributes") . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Выбор блога' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	
	if (($count = mysql_num_rows($query))) {
		echo '<select name="blog">' . "\n";
		echo '<option value="0">Выберите блог</option>' . "\n";
		
		while ($row = mysql_fetch_row($query)) {
			echo '<option value="' . $row[0] . '">' . $row[1] . '</option>' . "\n";
		}
		
		echo '</select>' . "\n";
	} else {
		echo 'Нет созданных коллективных блогов' . "\n";
	}
	
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	
	if ($count) {
		echo '<input type="submit" name="edit" value="Выбрать блог" /> ' . "\n";
		echo '<input type="submit" name="moderators" value="Модераторы блога" /> ' . "\n";
		echo '<input type="submit" name="delete" value="Удалить блог" /> ' . "\n";
	}
	
	echo '<input type="submit" name="create" value="Создать блог" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close($theme);
?>