<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("ONLY_ADMINS", 1);
define("HOME", "../");
define("PAGE", "admin_blogs_access.php");
define("TIME", microtime());

require("../wb-includes/common.php");

if (isset($_REQUEST['blog']) && is_unsigned($_REQUEST['blog'], true)) {
	/**
	 * Проверка существования блога
	 */
	$sql = 'select blog_id, blog_name from ' . BLOGS_TABLE . ' 
	where blog_id = ' . ($blog_id = $_REQUEST['blog']);
	
	$query = mysql_query($sql);
	$blog_data = mysql_fetch_assoc($query);
	
	if (!$blog_data) {
		redirect("admin_blogs_access.php");
	}
	
	if (isset($_POST["save"])) {
		/**
		 * Сохранение данных групп
		 */
		
		$theme = array (
			'Админ-панель',
			'Редактирование прав доступа групп к блогу "' . $blog_data["blog_name"] . '"',
			'<a href="admin_blogs_access.php?blog=' . $blog_id . '">Назад</a><br />' . "\n" .
			'<a href="../index.php">На главную</a>'
		);
		
		if (isset($_POST['array']) && is_array($_POST["array"])) {
			$array = $_POST['array'];
			$array_delete = array('group' => array(), 'user' => array());
			
			foreach ($array as $type => $sub_array) {
				// type: user or group
				$type = $type == 'groups' ? 'group' : 'user';
				
				/**
				 * Пробегаемся по массиву, обновляем записи к которым есть параметры;
				 * составляем список групп/юзеров для последующего удаления.
				 */
				foreach ($sub_array as $id => $access) {
					if (is_unsigned($id, true)) {
						$allow_approve_user = (int) isset($access["approve_user"]);
						$allow_delete_user = (int) isset($access["delete_user"]);
						$allow_edit_post = (int) isset($access["edit_post"]);
						$allow_delete_post = (int) isset($access["delete_post"]);
						$allow_edit_comment = (int) isset($access["edit_comment"]);
						$allow_delete_comment = (int) isset($access["delete_comment"]);
						
						if ($allow_approve_user || $allow_delete_user || $allow_edit_post || $allow_delete_post || $allow_edit_comment || $allow_delete_comment) {
							/**
							 * Обновление записи
							 */
							$sql = "update " . BLOGS_ACCESS_TABLE . " set 
							allow_approve_user = '" . $allow_approve_user . "',
							allow_delete_user = '" . $allow_delete_user . "',
							allow_edit_post = '" . $allow_edit_post . "',
							allow_delete_post = '" . $allow_delete_post . "',
							allow_edit_comment = '" . $allow_edit_comment . "',
							allow_delete_comment = '" . $allow_delete_comment . "'
							where " . $type . "_id = " . $id;
							
							mysql_query($sql);
						} else {
							$array_delete[$type][] = $id;
						}
					}
				}
			}
			
			/**
			 * Удаление групп/юзеров
			 */
			if (count($array_delete['group']) && count($array_delete['user'])) {
				$sql = "delete from " . BLOGS_ACCESS_TABLE . " where blog_id = " . $blog_id . " and (
				group_id in (" . implode(", ", $array_delete['group']) . ") or 
				user_id in (" . implode(", ", $array_delete['user']) . "))";
				
				mysql_query($sql);
			} elseif (count($array_delete['group'])) {
				$sql = "delete from " . BLOGS_ACCESS_TABLE . " where blog_id = " . $blog_id . " and 
				group_id in (" . implode(", ", $array_delete['group']) . ")";
				
				mysql_query($sql);
			} elseif (count($array_delete['user'])) {
				$sql = "delete from " . BLOGS_ACCESS_TABLE . " where blog_id = " . $blog_id . " and 
				user_id in (" . implode(", ", $array_delete['user']) . ")";
				
				mysql_query($sql);
			}
		}
		
		echo '<p>' . "\n";
		echo 'Права доступа изменены' . "\n";
		echo '</p>' . "\n";
	} elseif (isset($_POST["add"])) {
		/**
		 * Форма для добавления параметров для группы
		 */
		
		$theme = array (
			'Админ-панель',
			'Добавление прав доступа группы "' . $blog_data["blog_name"] . '"',
			'<a href="admin_blogs_access.php?blog=' . $blog_id . '">Назад</a><br />' . "\n" .
			'<a href="../index.php">На главную</a>'
		);
		
		if (isset($_POST["group"], $_POST["user"])) {
			if (is_unsigned($_POST["group"], true)) {
				$sql = "select group_id 
				from " . GROUPS_TABLE . " where group_id = " . $_POST["group"];
				
				$id = @mysql_result(mysql_query($sql), 0);
				$type = 'group';
				
				$id or redirect('admin_blog_access.php?blog=' . $blog_id);
			} else {
				$sql = 'select user_id from ' . USERS_TABLE . ' 
				where ' . (is_unsigned($_POST['user'], true) ? 'user_id' : 'user_login')  . ' = "' . mysql_escape_string(check($_POST['user'])) . '"';
				
				$id = @mysql_result(mysql_query($sql), 0);
				$type = 'user';
				
				$id or redirect('admin_blog_access.php?blog=' . $blog_id);
			}
			
			$allow_approve_user = (int) isset($_POST["approve_user"]);
			$allow_delete_user = (int) isset($_POST["delete_user"]);
			$allow_edit_post = (int) isset($_POST["edit_post"]);
			$allow_delete_post = (int) isset($_POST["delete_post"]);
			$allow_edit_comment = (int) isset($_POST["edit_comment"]);
			$allow_hide_comment = (int) isset($_POST["hide_comment"]);
			$allow_delete_comment = (int) isset($_POST["delete_comment"]);
			
			if ($allow_approve_user || $allow_delete_user || $allow_edit_post || $allow_delete_post || $allow_edit_comment || $allow_hide_comment || $allow_delete_comment) {
				
				$sql = "insert into " . BLOGS_ACCESS_TABLE . " (
				blog_id,
				user_id,
				group_id,
				allow_approve_user,
				allow_delete_user,
				allow_edit_post,
				allow_delete_post,
				allow_edit_comment,
				allow_delete_comment
				) values (
				" . $blog_id . ",
				" . ($type == 'user' ? $id : "NULL") . ",
				" . ($type == 'group' ? $id : "NULL") . ",
				'" . $allow_approve_user . "',
				'" . $allow_delete_user . "',
				'" . $allow_edit_post . "',
				'" . $allow_delete_post . "',
				'" . $allow_edit_comment . "',
				'" . $allow_delete_comment . "'
				)";
				
				mysql_query($sql);echo mysql_error();
				
				echo '<p>' . "\n";
				echo 'Права доступа для ' . ($type == 'user' ? 'указанного пользователя' : 'указанной группы') .  ' добавлены<br />' . "\n";
				echo '<a href="blogs_access.php?add&amp;blog=' . $blog_id . '">Добавить еще</a>' . "\n";
				echo '</p>' . "\n";
			} else {
				echo '<p>' . "\n";
				echo 'Не указаны права доступа<br />' . "\n";
				echo '<a href="blogs_access.php?add&amp;blog=' . $blog_id . '">Назад</a>' . "\n";
				echo '</p>' . "\n";
			}
		} else {
			$sql = "select group_id, group_name from " . GROUPS_TABLE . " 
			where group_id not in (select group_id from " . BLOGS_ACCESS_TABLE . " where blog_id = " . $blog_id . ")";
			
			$query = mysql_query($sql);
			
			echo '<form action="admin_blogs_access.php" method="post">' . "\n";
			echo '<input type="hidden" name="blog" value="' . $blog_id . '" />' . "\n";
			echo '<table ' . get_option('table_attributes') . '>' . "\n";
			echo '<tr>' . "\n";
			echo '<td id="title">' . "\n";
			echo 'Добавление прав доступа' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Группы..<br />' . "\n";
			echo '<select name="group">' . "\n";
			echo '<option value="0">Выберите</option>' . "\n";
			
			while ($rows = mysql_fetch_row($query)) {
				echo '<option value="' . $rows[0] . '">' . $rows[1] . '</option>' . "\n";
			}
			
			echo '</select>' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '.. или пользователя:<br />' . "\n";
			echo '<input type="text" name="user" value="" />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Права:<br />' . "\n";
			echo '<input type="checkbox" name="approve_user" value="1" /> Одобрение заявок на вступление в читателей<br />' . "\n";
			echo '<input type="checkbox" name="delete_user" value="1" /> Исключение пользователей из читателей<br />' . "\n";
			echo '<input type="checkbox" name="edit_post" value="1" /> Редактирование постов<br />' . "\n";
			echo '<input type="checkbox" name="delete_post" value="1" /> Удаление поста<br />' . "\n";
			echo '<input type="checkbox" name="edit_comment" value="1" /> Редактирование комментариев<br />' . "\n";
			echo '<input type="checkbox" name="delete_comment" value="1" /> Удаление комментариев<br />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			
			echo '<tr>' . "\n";
			echo '<td id="sub">' . "\n";
			echo '<input type="submit" name="add" value="Добавить" />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			
			echo '</table>' . "\n";
			echo '</form>' . "\n";
		}
	} else {
		/**
		 * Редактирование доступа групп к блогу
		 */
		
		$theme = array (
			'Админ-панель',
			'Редактирование прав доступа к блогу "' . $blog_data["blog_name"] . '"',
			'<a href="index.php">Админ-панель</a><br />' . "\n" .
			'<a href="../index.php">На главную</a>'
		);
		
		/**
		 * Получение параметров для всех групп, модерирующих блог
		 */
		$sql = "select a.*, g.group_name 
		from " . BLOGS_ACCESS_TABLE . " as a
		inner join " . GROUPS_TABLE . " as g using (group_id) 
		where a.blog_id = " . $blog_id . ' and a.group_id <> 0';
		
		$query = mysql_query($sql);
		
		echo '<form action="admin_blogs_access.php" method="post">' . "\n";
		echo '<input type="hidden" name="blog" value="' . $blog_id . '" />' . "\n";
		
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";	
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Редактирование прав доступа групп к блогу "' . $blog_data["blog_name"] . '"' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		if (mysql_num_rows($query)) {
			while ($fields = mysql_fetch_assoc($query)) {
				echo '<tr>' . "\n";
				echo '<td id="text">' . "\n";
				echo '<input type="hidden" name="array[groups][' . $fields['group_id'] . ']" />' . "\n";
				echo 'Название группы: ' . "\n";
				echo '<a href="../groups.php?group=' . $fields['group_id'] . '">' . $fields['group_name'] . '</a><br />' . "\n";
				echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][approve_user]" value="1" ' . ($fields['allow_approve_user'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Одобрение заявок на вступление в читателей<br />' . "\n";
				echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][delete_user]" value="1" ' . ($fields['allow_delete_user'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Исключение пользователей из читателей<br />' . "\n";
				echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][edit_post]" value="1" ' . ($fields['allow_edit_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Редактирование постов<br />' . "\n";
				echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][delete_post]" value="1" ' . ($fields['allow_delete_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Удаление поста<br />' . "\n";
				echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][edit_comment]" value="1" ' . ($fields['allow_edit_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
				echo 'Редактирование комментариев<br />' . "\n";
				echo '<input type="checkbox" name="array[groups][' . $fields['group_id'] . '][delete_comment]" value="1" ' . ($fields['allow_delete_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
				echo 'Удаление комментариев<br />' . "\n";
				echo '</td>' . "\n";
				echo '</tr>' . "\n";
			}
		} else {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Таких групп нет' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '<tr>' . "\n";
		echo '<td>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		/**
		 * Получение параметров для всех пользователей, модерирующих блог
		 */
		$sql = "select a.*, u.user_login 
		from " . BLOGS_ACCESS_TABLE . " as a
		inner join " . USERS_TABLE . " as u using (user_id) 
		where a.blog_id = " . $blog_id . ' and a.user_id <> 0';
		
		$query = mysql_query($sql);
		
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Редактирование прав доступа пользователей к блогу "' . $blog_data["blog_name"] . '"' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		if (mysql_num_rows($query)) {
			while ($fields = mysql_fetch_assoc($query)) {
				echo '<tr>' . "\n";
				echo '<td id="text">' . "\n";
				echo '<input type="hidden" name="array[users][' . $fields['user_id'] . ']" />' . "\n";
				echo 'Пользователь: ' . "\n";
				echo '<a href="../profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a><br />' . "\n";
				echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][approve_user]" value="1" ' . ($fields['allow_approve_user'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Одобрение заявок на вступление в читателей<br />' . "\n";
				echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][delete_user]" value="1" ' . ($fields['allow_delete_user'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Исключение пользователей из читателей<br />' . "\n";
				echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][edit_post]" value="1" ' . ($fields['allow_edit_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Редактирование постов<br />' . "\n";
				echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][delete_post]" value="1" ' . ($fields['allow_delete_post'] ? 'checked="checked" ' : '') . '/> ' . "\n";
				echo 'Удаление поста<br />' . "\n";
				echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][edit_comment]" value="1" ' . ($fields['allow_edit_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
				echo 'Редактирование комментариев<br />' . "\n";
				echo '<input type="checkbox" name="array[users][' . $fields['user_id'] . '][delete_comment]" value="1" ' . ($fields['allow_delete_comment'] ? 'checked="checked" ' : '') . '/>' . "\n";
				echo 'Удаление комментариев<br />' . "\n";
				echo '</td>' . "\n";
				echo '</tr>' . "\n";
			}
		} else {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Таких пользователей нет' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="save" value="Изменить" />' . "\n";
		echo '<input type="submit" name="add" value="Добавить &gt;" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} else {
	/**
	 * Выбор коллективного блога
	 */
	$theme = array (
		'Админ-панель',
		'Управление коллективными блогами',
		'<a href="index.php">Админ-панель</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = "select blog_id, blog_name from " . BLOGS_TABLE;
	$query = mysql_query($sql);
	
	/**
	 * Выбирать нечего, редирект на управление коллективными блогами
	 */
	if (!mysql_num_rows($query)) {
		redirect("admin_blogs_access.php");
	}
	
	echo '<form action="admin_blogs_access.php" method="post">' . "\n";
	echo '<table ' . get_option("table_attributes") . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Выбор блога' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo '<select name="blog">' . "\n";
	
	while ($row = mysql_fetch_row($query)) {
		echo '<option value="' . $row[0] . '">' . $row[1] . '</option>' . "\n";
	}
	
	echo '</select>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" value="Выбрать блог" /> ' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close($theme);
?>