<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define("IN_WBENGINE", 1);
define("ONLY_ADMINS", 1);
define("HOME", "../");
define("PAGE", "wb-admin/admin_groups.php");
define("TIME", microtime());

require("../wb-includes/common.php");

/**
 * Передан Id группы?
 */
$group_id = 0;
$group_data = array();

if (isset($_REQUEST['group']) && is_unsigned($_REQUEST['group'], true)) {
	$sql = 'select group_id, group_name, group_description from ' . GROUPS_TABLE . ' 
	where group_id = ' . ($group_id = $_REQUEST['group']);

	$query = mysql_query($sql);
	$group_data = mysql_fetch_assoc($query);
}

if (isset($_POST["save"])) {
	/**
	 * Сохранение изменений
	 */
	$theme = array (
		'Админ-панель',
		'Сохранение данных группы',
		'<a href="admin_groups.php">Группы</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$name = $description = '';
	
	if (isset($_POST['name'])) {
		$name = cut(check($_POST['name']), get_option('length_group_name'));
		$name = mysql_escape_string($name);
	}
	
	if (isset($_POST['description'])) {
		$description = cut(check($_POST['description'], true), get_option('length_group_description'));
		$description = mysql_escape_string($description);
	}
	
	if ($name) {
		if ($group_data) {
			$sql = 'update ' . GROUPS_TABLE . ' set 
			group_name = "' . $name . '",
			group_description = "' . $description . '"
			where group_id = ' . $group_id;
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Данные группы изменены<br />' . "\n";
			echo '<a href="admin_groups.php?edit&amp;group=' . $group_id . '">Назад</a>' . "\n";
			echo '</p>' . "\n";
		} else {
			$sql = 'insert into ' . GROUPS_TABLE . ' (
			group_name,
			group_description,
			group_add_time
			) values (
			"' . $name . '",
			"' . $description . '",
			"' . time() . '"
			)';
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Группа создана<br />' . "\n";
			echo '<a href="admin_groups.php?create">Создать еще</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Не введено имя!<br />' . "\n";
		echo '<a href="admin_groups.php' . ($group_data ? '?edit&amp;group=' . $group_id : '') . '">Назад</a>' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST["adduser"]) && $group_data) {
	/**
	 * Добавление пользователя в группу
	 */
	
	$theme = array (
		'Админ-панель',
		'Добавление участника',
		'<a href="admin_groups.php">Группы</a><br />' . "\n" . 
		'<a href="../index.php">На главную</a>'
	);
	
	if (isset($_POST["user"])) {
		$user = cut($_POST['user'], 25);
		$user = preg_replace('/[^A-z0-9\-_]/', '', $user);
		
		$sql = 'select user_id from ' . USERS_TABLE . '
		where ' . (is_unsigned($user, true) ? 'user_id' : 'user_login') . ' = "' . $user . '"';
		
		$query = mysql_query($sql);
		list($_user_id) = mysql_fetch_row($query);
		
		if ($_user_id) {
			$sql = 'insert into ' . GROUP_USER_TABLE . ' values (
			' . $group_id . ',
			' . $_user_id . '
			);';
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Участник добавлен<br />' . "\n";
			echo '<a href="admin_groups.php?adduser&amp;group=' . $group_id . '">Добавить еще</a><br />' . "\n";
			echo '<a href="admin_groups.php?users&amp;group=' . $group_id . '">Участники</a>' . "\n";
			echo '</p>' . "\n";
		} else {
			echo '<p>' . "\n";
			echo 'Пользователь не существует<br />' . "\n";
			echo '<a href="admin_groups.php?adduser&amp;group=' . $group_id . '">Добавить еще</a><br />' . "\n";
			echo '<a href="admin_groups.php?users&amp;group=' . $group_id . '">Участники</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<form action="admin_groups.php" method="post">' . "\n";
		echo '<input type="hidden" name="group" value="' . $group_id . '" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Добавление участника группы' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Логин или ID:<br />' . "\n";
		echo '<input type="text" name="user" value="" /> ' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="adduser" value="Добавить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} elseif (isset($_REQUEST["users"]) && $group_data) {
	/**
	 * Отображение списка участников группы
	 */
	
	$theme = array (
		'Админ-панель',
		'Управление участниками группы',
		'<a href="admin_groups.php">Группы</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	if (isset($_POST["delete"]) && is_array($_REQUEST["users"])) {
		/**
		 * Удаление пользователей из группы
		 */
		
		$users = array();
		
		foreach ($_REQUEST['users'] as $id) {
			if (is_unsigned($id, true)) {
				$users[] = $id;
			}
		}
		
		if (count($users)) {
			$sql = 'delete from ' . GROUP_USER_TABLE . ' 
			where group_id = ' . $group_id . ' and user_id in (' . implode(', ', $users) . ')';
			
			mysql_query($sql);
			
			echo '<p><span id="info">' . "\n";
			echo 'Указанные пользователи исключены из группы' . "\n";
			echo '</span></p>' . "\n";
		}
	}
	
	$sql = 'select gu.user_id, u.user_login 
	from ' . GROUP_USER_TABLE . ' as gu 
	inner join ' . USERS_TABLE . ' as u using (user_id) 
	where gu.group_id = ' . $group_id . ' order by u.user_login asc';
	
	$query = mysql_query($sql);
	
	echo '<form action="admin_groups.php" method="post">' . "\n";
	echo '<input type="hidden" name="group" value="' . $group_id . '" />' . "\n";
	echo '<input type="hidden" name="users" />' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Участники группы' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if (mysql_num_rows($query)) {
		while ($rows = mysql_fetch_row($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="checkbox" name="users[]" value="' . $rows[0] . '" /> ';
			echo '<a href="../profile.php?user=' . $rows[0] . '">' . $rows[1] . '</a> ';
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="delete" value="Исключить из группы" />' . "\n";
		echo '<input type="submit" name="adduser" value="Добавить &gt;" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	} else {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Учасников группы нет' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" name="adduser" value="Добавить &gt;" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
	echo '</form>' . "\n";
} elseif (isset($_POST["delete"]) && $group_data) {
	/**
	 * Удаление группы
	 */
	
	mysql_query('delete from ' . GROUPS_TABLE . ' where group_id = ' . $group_id);
	mysql_query('delete from ' . GROUP_USER_TABLE . ' where group_id = ' . $group_id);
	mysql_query('delete from ' . BLOG_GROUP_TABLE . ' where group_id = ' . $group_id);
	
	redirect('admin_groups.php');
} elseif (isset($_REQUEST["create"]) || isset($_REQUEST["edit"])) {
	/**
	 * Форма для добавления / редактирования группы
	 */
	
	$theme = array (
		'Админ-панель',
		$group_data ? 'Редактирование группы' : 'Создание группы',
		'<a href="admin_groups.php">Группы</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	echo '<form action="admin_groups.php?' . ($group_data ? 'group=' . $group_id : '') . '" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo ($group_data ? 'Редактирование группы' : 'Создание группы') . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Название группы:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('length_group_name') . ' символов</span><br />' . "\n";
	echo '<input type="text" name="name" maxlength="' . get_option('length_group_name')  . '" value="' . ($group_data ? $group_data["group_name"] : '') . '" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Описание группы:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('length_group_description') . ' символов</span><br />' . "\n";
	echo '<textarea name="description" maxlength="' . get_option('length_group_description')  . '" ' . get_option('textarea_attributes') . '>' . ($group_data ? $group_data["group_description"] : '') . '</textarea>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	echo '<input type="submit" name="save" value="' . ($group_data ? 'Изменить группу' : 'Создать группу') . '" /> ' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
} else {
	/**
	 * Выбор группы
	 */
	
	$theme = array (
		'Админ-панель',
		'Управление группами',
		'<a href="index.php">Админ-панель</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = "select group_id, group_name from " . GROUPS_TABLE;
	$query = mysql_query($sql);
	
	echo '<form action="admin_groups.php" method="post">' . "\n";
	echo '<table ' . get_option("table_attributes") . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Выбор группы' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	
	if (($count = mysql_num_rows($query))) {
		echo '<select name="group">' . "\n";
		echo '<option value="0">Выберите группу</option>' . "\n";
		
		while ($row = mysql_fetch_row($query)) {
			echo '<option value="' . $row[0] . '">' . $row[1] . '</option>' . "\n";
		}
		
		echo '</select>' . "\n";
	} else {
		echo 'Нет созданных групп' . "\n";
	}
	
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="sub">' . "\n";
	
	if ($count) {
		echo '<input type="submit" name="edit" value="Выбрать группу" /> ' . "\n";
		echo '<input type="submit" name="users" value="Участники группы" /> ' . "\n";
		echo '<input type="submit" name="delete" value="Удалить группу" /> ' . "\n";
	}
	
	echo '<input type="submit" name="create" value="Создать группу" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
}

close($theme);
?>