<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('HOME', '../');
define('PAGE', 'blogs/blogs.php');
define('TIME', microtime());

require ('../wb-includes/common.php');
require ('../wb-includes/plugins/blogs.php');

/**
 * Получение информации о блоге
 */
$blog_data = false;

if (isset($_REQUEST['blog']) && is_unsigned($_REQUEST['blog'], true)) {
	$sql = 'select * from ' . BLOGS_TABLE . ' 
	where blog_id = ' . ($blog_id = $_REQUEST['blog']);
	
	$query = mysql_query($sql);
	$blog_data = mysql_fetch_assoc($query);
	
	if (!$blog_data) {
		redirect('blogs.php');
	}
}

if ((isset($_POST['approve']) || isset($_POST['delete'])) && $blog_data) {
	/**
	 * Одобрение заявок / удаление пользователей
	 */
	
	do {
		/**
		 * Проверка переданного массива пользователей
		 */
		if (!isset($_POST['users']) || !is_array($_POST['users'])) {
			break;
		}
		
		$users = array();
		
		foreach ($_POST['users'] as $id) {
			if (is_unsigned($id, true)) {
				$users[] = $id;
			}
		}
		
		if (!count($users)) {
			break;
		}
		
		$users = implode(',', $users);
		
		if (isset($_POST['approve'])) {
			/**
			 * Получение полномочий
			 */
			$access = get_blogs_access($blog_id, 'approve_user');
			
			if (!$access['approve_user']) {
				break;
			}
			
			mysql_query('update ' . BLOGS_USER_TABLE . ' set is_entry = "0" 
			where blog_id = ' . $blog_id . ' and user_id in (' . $users . ')');
		} else {
			/**
			 * Получение полномочий
			 */
			$access = get_blogs_access($blog_id, 'delete_user');
			
			if (!$access['delete_user']) {
				break;
			}
			
			mysql_query('delete from ' . BLOGS_USER_TABLE . ' 
			where blog_id = ' . $blog_id . ' and user_id in (' . $users . ')');
		}
	} while (0);
	
	update_blog_count_users($blog_id);
	redirect('blogs.php?blog=' . $blog_id);
	
} elseif (isset($_REQUEST['entries']) && $blog_data) {
	/**
	 * Заявки на вступление в Читатели блога
	 */
	
	/**
	 * Получение полномочий
	 */
	$access = get_blogs_access($blog_id, array('approve_user', 'delete_user'));
	
	if (!$access['approve_user'] && !$access['delete_user']) {
		redirect('blogs.php?blog=' . $blog_id);
	}
	
	$theme = array (
		'Блоги',
		'Заявки на вступление в читателей блога "' . $blog_data['blog_name'] . '"',
		'<a href="blogs.php?blog=' . $blog_id . '">Назад</a><br />' . 
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = 'select count(*) from ' .BLOGS_USER_TABLE . ' 
	where blog_id = ' . $blog_id . ' and is_entry = "1"';
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select b.user_id, u.user_login from ' . BLOGS_USER_TABLE . ' as b 
		inner join ' . USERS_TABLE . ' as u using(user_id) 
		where b.blog_id = ' . $blog_id . ' and is_entry = "1" 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		echo '<form action="blogs.php?blog=' . $blog_id . '" method="post">' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Заявки на вступление в Читатели блога' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="checkbox" name="users[]" value="' . $fields['user_id'] . '" /> ';
			echo '<a href="../profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
			
			switch (is_online($fields['user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo $access['approve_user'] ? '<input type="submit" name="approve" value="Одобрить" />' . "\n" : '';
		echo $access['delete_user'] ? '<input type="submit" name="delete" value="Исключить" />' . "\n" : '';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего пользователей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'blogs.php?entries&amp;blog=' . $blog_id . '&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Нет заявок на ступление в Читатели блога' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST['members']) && $blog_data) {
	/**
	 * Читатели блога
	 */
	
	$theme = array (
		'Блоги',
		'Читатели блога "' . $blog_data['blog_name'] . '"',
		'<a href="blogs.php?blog=' . $blog_id . '">Назад</a><br />' . 
		'<a href="../index.php">На главную</a>'
	);
	
	/**
	 * Получение полномочий
	 */
	$access = get_blogs_access($blog_id, 'delete_user');
	$access = $access['delete_user'];
	
	$sql = 'select count(*) from ' .BLOGS_USER_TABLE . ' 
	where blog_id = ' . $blog_id . ' and is_entry = "0"';
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select b.user_id, u.user_login from ' . BLOGS_USER_TABLE . ' as b 
		inner join ' . USERS_TABLE . ' as u using(user_id) 
		where b.blog_id = ' . $blog_id . ' and is_entry = "0" 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		echo $access ? '<form action="blogs.php?blog=' . $blog_id . '" method="post">' . "\n" : '';
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Читатели блога' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo $access ? '<input type="checkbox" name="users[]" value="' . $fields['user_id'] . '" /> ' : '';
			echo '<a href="../profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login'] . '</a> ';
			
			switch (is_online($fields['user_id'])) {
				case USER_ONLINE:
					echo '<span id="online">[On]</span>' . "\n";
					break;
				
				case USER_OFFLINE:
					echo '<span id="offline">[Off]</span>' . "\n";
					break;
				
				case USER_HIDE:
					echo '<span id="hide">[Hid]</span>' . "\n";
			}
			
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		if ($access) {
			echo '<tr>' . "\n";
			echo '<td id="sub">' . "\n";
			echo '<input type="submit" name="delete" value="Исключить" />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		echo $access ? '</form>' . "\n" : '';
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего пользователей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'blogs.php?members&amp;blog=' . $blog_id . '&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'У блога пока нет читателей' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST['subscribe']) && $blog_data && $is_logged) {
	/**
	 * Вступление в группу
	 */
	
	$theme = array (
		'Блоги', 
		'Вступление в Блог', 
		'<a href="blogs.php?blog=' . $blog_id . '">Назад</a><br />' . "\n" . 
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = 'select count(*) from ' . BLOGS_USER_TABLE . ' 
	where blog_id = ' . $blog_id . ' and user_id = ' . $user_id;
	
	/**
	 * Закрыто вступление новых пользователей или пользователь - уже читатель
	 */
	if ($blog_data['blog_type'] == BLOG_CLOSE || mysql_result(mysql_query($sql), 0)) {
		redirect('index.php?blog=' . $blog_id);
	}
	
	$sql = 'insert into ' . BLOGS_USER_TABLE . ' (
	blog_id,
	user_id,
	is_entry
	) values (
	' . $blog_id . ',
	' . $user_id . ',
	"' . ($blog_data['blog_type'] == BLOG_ENTRY ? 1 : 0) . '"
	)';
	
	mysql_query($sql);
	
	if ($blog_data['blog_type'] == BLOG_ENTRY) {
		echo '<p>' . "\n";
		echo 'Вы попросили о вступлении в Читатели блога. Ожидайте проверки модераторов.' . "\n";
		echo '</p>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo 'Вы вступили в читателей блога' . "\n";
		echo '</p>' . "\n";

/** апдейт кол-ва юзеров в блоге */
update_blog_count_users($blog_id);
	}
} elseif (isset($_REQUEST['unsubscribe']) && $blog_data && $is_logged) {	
	/**
	 * Отпись из группы
	 */
	
	$theme = array (
		'Группы', 
		'Отпись из группы', 
		'<a href="blogs.php?blog=' . $blog_id . '">Назад</a><br />' . "\n" . 
		'<a href="../index.php">На главную</a>'
	);
	
	mysql_query('delete from ' . BLOGS_USER_TABLE . ' where blog_id = ' . $blog_id . ' and user_id = ' . $user_id);
	update_blog_count_users($blog_id);
	
	echo '<p>' . "\n";
	echo 'Вы отписались из читателей блога' . "\n";
	echo '</p>' . "\n";
	
} elseif ($blog_data) {
	/** 
	 * Просмотр информации о блоге
	 */
	
	$theme = array (
		'Блог "' . $blog_data['blog_name'] . '"',
		'Инфрормация о блоге',
		'<a href="blogs.php">К блогам</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Коллективный блог "' . $blog_data['blog_name'] . '"';
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if ($blog_data['blog_description']) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Описание:<br />' . "\n";
		echo tags($blog_data['blog_description']) . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Дата создания:<br />' . "\n";
	echo fdate($blog_data['blog_add_time']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	/**
	 * Модераторы блога
	 */
	$moderators = array();
	
	$sql = 'select a.group_id, a.user_id, g.group_name, u.user_login 
	from ' . BLOGS_ACCESS_TABLE . ' as a 
	left join ' . GROUPS_TABLE . '  as g on (a.group_id <> 0 and g.group_id = a.group_id) 
	left join ' . USERS_TABLE . '  as u on (a.user_id <> 0 and u.user_id = a.user_id) 
	where a.blog_id = ' . $blog_id;
	
	$query = mysql_query($sql);
	
	while ($rows = mysql_fetch_row($query)) {
		if ($rows[0]) {
			$moderators[] = '<a href="../groups.php?group=' . $rows[0] . '">' . $rows[2] . '</a>';
		} else {
			$moderators[] = '<a href="../profile.php?user=' . $rows[1] . '">' . $rows[3] . '</a>';
		}
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Модераторы:<br />' . "\n";
	echo (count($moderators) ? implode(' &#x25AA; ', $moderators) : 'нет') . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	
	/**
	 * Отображение ссылки "вступление в блог"
	 */
	if ($is_logged) {
		$sql = 'select count(*) from ' . BLOGS_USER_TABLE . '
		where blog_id = ' . $blog_id  . ' and user_id = ' . $user_id;
		
		$query = mysql_query($sql);
		$is_member = (bool) mysql_result($query, 0);
	}
	
	/**
	 * Отображение линка "заявки на вступление"
	 */
	$access = get_blogs_access($blog_id, array('delete_user', 'approve_user'));
	
	if ($access['approve_user'] || $access['delete_user']) {
		$sql = 'select count(*) from ' .BLOGS_USER_TABLE . ' 
		where blog_id = ' . $blog_id . ' and is_entry = "1"';
		
		$query = mysql_query($sql);
		$count = mysql_result($query, 0);
	}
	
	/**
	 * Кол-во записей в блоге
	 */
	$sql = 'select count(*) from ' . BLOG_POSTS_TABLE . ' where blog_id = ' . $blog_id;
	$count_posts = mysql_result(mysql_query($sql), 0);
	
	echo '<p>';
	echo '<a href="index.php?blog=' . $blog_id  . '">Записи в блоге (' . $count_posts . ')</a><br />';
	echo '<a href="blogs.php?members&amp;blog=' . $blog_id . '">Читатели (' . $blog_data['blog_count_users'] . ')</a><br />' . "\n";
	echo $access['approve_user'] || $access['delete_user'] ? '<a href="blogs.php?entries&amp;blog=' . $blog_id . '">Заявки на вступление (' . $count . ')</a><br />' . "\n" : '';
	echo $is_logged ? '<a href="blogs.php?' . ($is_member ? 'un' : '')  . 'subscribe&amp;blog=' . $blog_id . '">' . ($is_member ? 'Отписаться из блога' : 'Вступить в блог') . '</a>' . "\n" : '';
	echo '</p>';
} else {
	/**
	 * Коллективные блоги
	 */
	
	$theme = array (
		'Коллективные блоги',
		'Коллективные блоги',
		'<a href="index.php">К блогам</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	$sql = 'select count(*) from ' . BLOGS_TABLE;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select blog_id, blog_name, blog_rating, blog_count_vote, blog_count_users 
		from ' . BLOGS_TABLE . ' order by blog_rating desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Коллективные блоги' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";	
			echo '<a href="blogs.php?blog=' . $fields['blog_id'] . '">' . $fields['blog_name'] . '</a><br />' . "\n";
			echo '<a href="blogs.php?members&amp;blog=' . $fields['blog_id'] . '">Читатели: ' . $fields['blog_count_users'] . '</a>' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo 'Коллективных блогов пока нет' . "\n";
		echo '</p>' . "\n";
	}
}

close($theme);
?>