<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('HOME', '../');
define('PAGE', 'blogs/index.php');
define('TIME', microtime());

require('../wb-includes/common.php');
require('../wb-includes/plugins/blogs.php');

if (isset($_REQUEST['friends']) && $is_logged) {
	/**
	 * Записи друзей
	 */
	
	/**
	 * Получение списка друзей
	 */
	$sql = 'select friend_user_id 
	from ' . FRIENDS_TABLE . ' where user_id = ' . $user_id;
	
	$friends = array();
	$query = mysql_query($sql);
	
	while ($row = mysql_fetch_row($query)) {
		$friends[] = $row[0];
	}
	
	if (count($friends)) {
		$sql = 'select count(*) from ' . BLOG_POSTS_TABLE . ' 
		where blog_id = 0 and user_id in (' . ($friends = implode(', ', $friends)) . ')';
		
		$query = mysql_query($sql);
		$count = mysql_result($query, 0);
		
		echo '<p>' . "\n";
		echo '<a href="index.php">Все</a> &rarr; ';
		echo '<a href="index.php?blogs">Коллективные</a> &rarr; ';
		echo '<a href="index.php?users">Личные</a>';
		echo '</p>' . "\n";
		
		if ($count) {
			/**
			 * Вывод записей блога
			 */
			
			echo '<table ' . get_option('table_attributes') . '>' . "\n";
			echo '<tr>' . "\n";
			echo '<td id="title">' . "\n";
			echo 'Личные блоги' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			
			$pagination = pagination_main($count, get_nav_posts());
			
			$sql = 'select p.*, u.user_login 
			from  ' . BLOG_POSTS_TABLE . ' as p 
			inner join ' . USERS_TABLE . ' as u using (user_id) 
			where p.blog_id = 0 and user_id in (' . $friends . ') 
			order by p.post_add_time desc 
			limit ' . $pagination['start'] . ', ' . $pagination['end'];
			
			$query = mysql_query($sql);
			
			while ($post_data = mysql_fetch_assoc($query)) {
				/**
				 * Пользователь удален, но записи в блоге остались, необходимо удалить
				 */
				if (!$post_data['user_login']) {
					mysql_query('delete from ' . BLOG_POSTS_TABLE . ' where user_id = "' . $post_data['user_id']);
					continue;
				}
				
				echo '<tr>' . "\n";
				echo '<td id="text">' . "\n";
				echo 'Блог им. <a href="index.php?user=' . $post_data['user_id'] . '">' . $post_data['user_login']  . '</a> &rarr; ';
				echo '<a href="post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . ' </a> от ' . fdate($post_data['post_add_time']) . '<br />' . "\n";
				echo 'Рейтинг: ' . $post_data['post_rating'] .  ' / ' . $post_data['post_count_vote'] .  ' ';
				echo '</td>' . "\n";
				echo '</tr>' . "\n";
			}
			
			echo '</table>' . "\n";
			
			if ($pagination['all_pages'] > 1) {
				echo '<p>' . "\n";
				echo 'Всего записей: ' . $count . '<br />' . "\n";
				echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'index.php?users&amp;page=%d') . "\n";
				echo '</p>' . "\n";
			}
		} else {
			echo '<p>' . "\n";
			echo 'Записей пока нет' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Друзей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	$theme = array (
		'Лента друзей',
		'Лента друзей',
		'<a href="../index.php">На главную</a>'
	);

} elseif (isset($_REQUEST['user']) && is_unsigned($_REQUEST['user'], true)) {
	/**
	 * Посты личного блога и все посты пользователя
	 */
	$view_all = isset($_REQUEST['all']);
	
	/**
	 * Проверка существование блога
	 */
	if ($is_logged && $user_id == $_REQUEST['user']) {
		$_user_data = array (
			'user_id' => $user_data['user_id'],
			'user_login' => $user_data['user_login'],
		);
	} else {
		$sql = 'select user_id, user_login 
		from ' . USERS_TABLE . ' where user_id = ' . $_REQUEST['user'];
		
		$query = mysql_query($sql);
		$_user_data = mysql_fetch_assoc($query);
		
		if (!$_user_data) {
			redirect('index.php');
		}
	} 
	
	/** 
	 * Получение колличества сообщений
	 */
	$sql = 'select count(*) from ' . BLOG_POSTS_TABLE . ' 
	where ' . ($view_all ? '' : 'blog_id = 0 and ') . 'user_id = ' . $_user_data['user_id'];
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	echo '<p>' . "\n";
	echo '<a href="index.php">Все</a> &rarr; ' . "\n";
	echo '<a href="index.php?blogs">Коллективные</a> &rarr; ' . "\n";
	echo '<a href="index.php?users">Личные</a>' . "\n";
	echo $is_logged ? ' &rarr; <a href="index.php?friends">Лента друзей</a>' : '';
	echo '</p>' . "\n";
	
	echo '<p>' . "\n";
	echo 'Отображать <a href="index.php?user=' . $_user_data['user_id'] . ($view_all ? '' : '&amp;all') . '">' . ($view_all ? 'записи в личном блоге' : 'записи во всех блогах') . '</a>' . "\n";
	echo '</p>' . "\n";
	
	if ($count) {
		/**
		 * Вывод записей блога
		 */
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo $view_all ? 'Все записи ' : 'Блог им. ';
		echo '<a href="../profile.php?user=' . $_user_data['user_id'] . '">' . $_user_data['user_login'] . '</a>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$pagination = pagination_main($count, get_nav_posts());
		
		if ($view_all) {
			$sql = 'select p.*, b.blog_name 
			from  ' . BLOG_POSTS_TABLE . ' as p 
			left join ' . BLOGS_TABLE . ' as b using (blog_id)
			where p.user_id = ' . $_user_data['user_id'] . ' order by p.post_add_time desc 
			limit ' . $pagination['start'] . ', ' . $pagination['end'];
		} else {
			$sql = 'select * from  ' . BLOG_POSTS_TABLE . ' 
			where blog_id = 0 and user_id = ' . $_user_data['user_id'] . ' 
			order by post_add_time desc limit ' . $pagination['start'] . ', ' . $pagination['end'];
		}
		
		$query = mysql_query($sql);
		
		while ($post_data = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			
			if ($view_all) {
				if ($post_data['blog_id']) {
					echo 'Блог <a href="index.php?blog=' . $post_data['blog_id'] . '">' . $post_data['blog_name'] . '</a> &rarr; ';
				} else {
					echo 'Блог им. <a href="index.php?user=' . $post_data['user_id'] . '">' . $_user_data['user_login']  . '</a> &rarr; ';
				}
				
				echo '<br />' . "\n";
			}
			
			echo '<a href="post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . ' </a> от ' . fdate($post_data['post_add_time']) . '<br />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего записей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'index.php?user=' . $_user_data['user_id'] . ($view_all ? '&amp;all' : '') . '&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Записей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($is_logged && $user_id == $_user_data['user_id'] && !$view_all) {
		echo '<p>' . "\n";
		echo '<a href="addpost.php?w=0">Добавить запись</a>' . "\n";
		echo '</p>' . "\n";
	}
	
	$theme = array (
		'Блог  им. ' . $_user_data['user_login'],
		'Блог  им. ' . $_user_data['user_login'],
		'<a href="../index.php">На главную</a>'
	);
	
} elseif (isset($_REQUEST['blog']) && is_unsigned($_REQUEST['blog'], true)) {
	/**
	 * Посты коллективного блога
	 */
	
	/**
	 * Проверка существование блога
	 */
	$sql = 'select blog_name from ' . BLOGS_TABLE . ' 
	where blog_id = ' . ($blog_id = $_REQUEST['blog']);
	
	$query = mysql_query($sql);
	$blog_data = mysql_fetch_assoc($query);
	
	if (!$blog_data) {
		redirect('index.php');
	}
	
	/** 
	 * Получение колличества сообщений
	 */
	$sql = 'select count(*) 
	from ' . BLOG_POSTS_TABLE . ' where blog_id = ' . $blog_id;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	echo '<p>' . "\n";
	echo '<a href="index.php">Все</a> &rarr; ';
	echo '<a href="index.php?blogs">Коллективные</a> &rarr; ';
	echo '<a href="index.php?users">Личные</a> ';
	echo $is_logged ? ' &rarr; <a href="index.php?friends">Лента друзей</a>' : '';
	echo '</p>' . "\n";
	
	if ($count) {
		/**
		 * Вывод записей блога
		 */
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Блог <a href="blogs.php?blog=' . $blog_id . '">' . $blog_data['blog_name'] . '</a>' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select * from  ' . BLOG_POSTS_TABLE . ' 
		where blog_id = ' . $blog_id . ' order by post_add_time desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($post_data = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<a href="post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . ' </a> от ' . fdate($post_data['post_add_time']) . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего записей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'index.php?blog=' . $blog_id . '&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Записей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	/**
	 * Добавление записи
	 * Только для читателей группы и пользователей, участвующих в группах модераторов
	 */
	if ($is_logged && (is_blog_user($blog_id, $user_id) || array_sum(get_blogs_access($blog_id)))) {
		echo '<p>' . "\n";
		echo '<a href="addpost.php?w=1&amp;blog=' . $blog_id . '">Добавить запись</a>' . "\n";
		echo '</p>' . "\n";
	}
	
	$theme = array (
		'Блог ' . $blog_data['blog_name'],
		'Блог ' . $blog_data['blog_name'],
		'<a href="../index.php">На главную</a>'
	);
	
} elseif (isset($_REQUEST['users'])) {
	/**
	 * Личные блоги
	 */
	
	$sql = 'select count(*) 
	from ' . BLOG_POSTS_TABLE . ' where blog_id = 0';
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	echo '<p>' . "\n";
	echo '<a href="index.php">Все</a> &rarr; ';
	echo '<a href="index.php?blogs">Коллективные</a>';
	echo $is_logged ? ' &rarr; <a href="index.php?friends">Лента друзей</a>' : '';
	echo '</p>' . "\n";
	
	if ($count) {
		/**
		 * Вывод записей блога
		 */
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Личные блоги' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select p.*, u.user_login
		from  ' . BLOG_POSTS_TABLE . ' as p 
		inner join ' . USERS_TABLE . ' as u using (user_id) 
		where p.blog_id = 0  order by p.post_add_time desc
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($post_data = mysql_fetch_assoc($query)) {
			/**
			 * Пользователь удален, но записи в блоге остались, необходимо удалить
			 */
			if (!$post_data['user_login']) {
				mysql_query('delete from ' . BLOG_POSTS_TABLE . ' where user_id = "' . $post_data['user_id']);
				continue;
			}
			
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Блог им. <a href="index.php?user=' . $post_data['user_id'] . '">' . $post_data['user_login']  . '</a> &rarr; <br />';
			echo '<a href="post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . ' </a> от ' . fdate($post_data['post_add_time']) . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего записей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'index.php?users&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Записей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	$theme = array (
		'Личные блоги',
		'Личные блоги',
		'<a href="../index.php">На главную</a>'
	);
	
} elseif (isset($_REQUEST['blogs'])) {
	/**
	 * Коллективные блоги
	 */
	
	$sql = 'select count(*) 
	from ' . BLOG_POSTS_TABLE . ' where blog_id <> 0';
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	echo '<p>' . "\n";
	echo '<a href="index.php">Все</a> &rarr; ';
	echo '<a href="index.php?users">Личные</a>';
	echo $is_logged ? ' &rarr; <a href="index.php?friends">Лента друзей</a>' : '';
	echo '</p>' . "\n";
	
	if ($count) {
		/**
		 * Вывод записей блога
		 */
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Коллективные блоги' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select p.*, b.blog_name 
		from  ' . BLOG_POSTS_TABLE . ' as p 
		inner join ' . BLOGS_TABLE . ' as b using (blog_id) 
		where p.blog_id <> 0 order by p.post_add_time desc
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($post_data = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'Блог <a href="index.php?blog=' . $post_data['blog_id'] . '">' . $post_data['blog_name'] . '</a> &rarr; <br />' . "\n";
			echo '<a href="post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . ' </a> от ' . fdate($post_data['post_add_time']) . '<br />' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего записей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'index.php?blogs&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Записей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	$theme = array (
		'Коллективные блоги',
		'Коллективные блоги',
		'<a href="../index.php">На главную</a>'
	);
	
} else {
	/**
	 * Главная страница
	 */
	
	$sql = 'select count(*) from ' . BLOG_POSTS_TABLE;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		/**
		 * Вывод записей блога
		 */
		
		echo '<p>' . "\n";
		echo '<a href="index.php?blogs">Коллективные</a> &rarr; ';
		echo '<a href="blogs.php">Все коллективные блоги</a> &rarr; ';
		echo '<a href="index.php?users">Личные</a>';
		echo $is_logged ? ' &rarr; <a href="index.php?friends">Лента друзей</a>' : '';
		echo '</p>' . "\n";
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Все блоги' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select p.*, b.blog_name, u.user_login 
		from  ' . BLOG_POSTS_TABLE . ' as p 
		left join ' . BLOGS_TABLE . ' as b using (blog_id) 
		left join ' . USERS_TABLE . ' as u on (u.user_id = p.user_id) 
		order by p.post_add_time desc
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		while ($post_data = mysql_fetch_assoc($query)) {
			/**
			 * Пользователь удален, но записи в блоге остались, необходимо удалить
			 */
			if (!$post_data['user_login']) {
				mysql_query('delete from ' . BLOG_POSTS_TABLE . ' where user_id = ' . $post_data['user_id']);
				continue;
			}
			
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			
			if ($post_data['blog_id']) {
				echo 'Блог <a href="index.php?blog=' . $post_data['blog_id'] . '">' . $post_data['blog_name'] . '</a> &rarr; ';
			} else {
				echo 'Блог им. <a href="../profile.php?user=' . $post_data['user_id'] . '">' . $post_data['user_login']  . '</a> &rarr; ';
			}
			
			echo '<br />' . "\n";
			echo '<a href="post.php?post=' . $post_data['post_id'] . '"> ' . $post_data['post_title'] . '</a> от ' . fdate($post_data['post_add_time']) . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего записей: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'index.php?page=%d') . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo 'Записей пока нет' . "\n";
		echo '</p>' . "\n";
	}
	
	echo '<p><a href="addpost.php">Добавить запись</a></p>' . "\n";
	
	$theme = array (
		'Все блоги',
		'Все блоги',
		'<a href="../index.php">На главную</a>'
	);
}

close($theme);
?>