<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('HOME', '../');
define('PAGE', 'blogs/post.php');
define('TIME', microtime());

require ('../wb-includes/common.php');
require ('../wb-includes/plugins/blogs.php');
require ('../wb-includes/plugins/friends.php');

if (empty($_REQUEST['post']) || !is_unsigned($_REQUEST['post'], true)) {
	redirect('index.php');
}

/**
 * Проверка указанного Id поста, получение данных поста
 */
$sql = 'select p.*, u1.user_login, u2.user_login as post_edit_user_login
from ' . BLOG_POSTS_TABLE . ' as p 
left join ' . USERS_TABLE . ' as u1 using (user_id) 
left join ' . USERS_TABLE . ' as u2 on (u2.user_id = p.post_edit_user_id) 
where p.post_id = ' . ($post_id = $_REQUEST['post']);

$query = mysql_query($sql);
$post_data = mysql_fetch_assoc($query);

if (!$post_data) {
	redirect('index.php');
}

/**
 * Проверка существования блога (если запись сделана в коллективном блоге)
 */
$blog_id = false;
$blog_data = false;

if ($post_data['blog_id']) {
	$sql = 'select blog_name 
	from ' . BLOGS_TABLE . ' where blog_id = ' . ($blog_id = $post_data['blog_id']);
	
	$query = mysql_query($sql);
	$blog_data = mysql_fetch_assoc($query);
	
	/**
	 * Блог не существует, удаление записей этого блога
	 */
	if (!$blog_data) {
		mysql_query('delete from ' . BLOG_POSTS_TABLE . ' where blog_id = ' . $blog_id);
		redirect('index.php');
	}
}

/**
 * Действия
 */
if (isset($_REQUEST['delete']) && $is_logged) {
	/**
	 * Удаление поста
	 */
	
	if ($post_data['user_id'] != $user_id) {
		if ($blog_id) {
			$access = get_blogs_access($blog_id, 'delete_post');
		} else {
			$access = get_blog_access('delete_post');
		}
		
		if (!$access['delete_post']) {
			redirect('index.php');
		}
	}
	
	mysql_query('delete from ' . BLOG_TAGS_TABLE . ' where post_id = ' . $post_id);
	mysql_query('delete from ' . BLOG_POSTS_TABLE . ' where post_id = ' . $post_id);
	mysql_query('delete from ' . BLOG_COMMENTS_TABLE . ' where post_id = ' . $post_id);
	redirect('index.php?' . ($blog_id ? 'blog=' . $blog_id : 'user=' . $post_data['user_id']));
} else {
	/**
	 * Просмотр поста
	 */
	
	$theme = array (
		'Запись "' . $post_data['post_title'] . '"',
		'Запись "' . $post_data['post_title'] . '"',
		'<a href="index.php?' . ($post_data['blog_id'] ? 'blog=' . $post_data['blog_id'] : 'user=' . $post_data['user_id']) . '">К блогу</a><br />' . "\n" .
		'<a href="../index.php">На главную</a>'
	);
	
	if ($post_data['blog_id']) {
		do {
			/**
			 * Доступ к комментированию открыт для всех
			 */
			$allow_comments = $post_data['privacy_comments'] == BLOG_COMMENTS_USERS;
			$access = array('edit_post' => false, 'delete_post' => false);
			
			if ($is_logged) {
				/**
				 * Читатель блога? (если нужно)
				 */
				if ($user_id == $post_data['user_id'] || $post_data['privacy_post'] == BLOG_POST_MEMBERS) {
					$is_blog_user = is_blog_user($blog_id, $user_id);
				}
				
				/**
				 * Автор (действующий читатель блога!) может читать, редактировать, удалять запись,
				 * просматривать комментарии к записи
				 */
				if ($user_id == $post_data['user_id'] && $is_blog_user) {
					$allow_comments = true;
					$access['edit_post'] = true;
					$access['delete_post'] = true;
					break;
				}
				
				/**
				 * Получение прав доступа к модерированию поста (и комментариев)
				 */
				$access = array('edit_post', 'delete_post', 'edit_comment', 'delete_comment');
				$access = get_blogs_access($blog_id, $access);
				
				if ($access['edit_post'] || $access['delete_post']) {
					/**
					 * Комментарии открыты или есть полномочия для изменения / удаления комментариев
					 */
					if ($access['edit_comment'] || $access['delete_comment'] || $post_data['privacy_comments'] != BLOG_COMMENTS_DISABLE) {
						$allow_comments = true;
					}
					break;
				}
				
				/**
				 * Читатели группы могут читать записи
				 */
				if ($post_data['privacy_post'] == BLOG_POST_MEMBERS && $is_blog_user) {
					/**
					 * Комментарии для читателей блога или для всех пользователей
					 */
					if ($post_data['privacy_comments'] != BLOG_COMMENTS_DISABLE) {
						$allow_comments = true;
					}
					break;
				}
			}
			
			if ($post_data['privacy_post'] == BLOG_POST_USERS) {
				break;
			}
			
			echo '<p>' . "\n";
			echo 'Просмотр этой записи доступен только читателям блога';
			echo '</p>' . "\n";
			
			close($theme);
		} while (0);
	} else {
		/**
		 * Личный блог
		 */
		do {
			/**
			 * Доступ к комментированию открыт для всех?
			 */
			$allow_comments = $post_data['privacy_comments'] == BLOG_COMMENTS_USERS;
			$access = array('edit_post' => false, 'delete_post' => false);
			
			if ($is_logged) {
				/**
				 * Владелец блога
				 */
				if ($user_id == $post_data['user_id']) {
					$access = array('edit_post' => true, 'delete_post' => true);
					$allow_comments = true;
					break;
				}
				
				/**
				 * Участие в группах модераторов
				 */
				$access = array('view_post', 'edit_post', 'delete_post', 'view_comments');
				$access = get_blog_access($access);
				
				$allow_comments = $allow_comments || $access['view_comments'];
				
				/**
				 * Если есть доступ к просмотру поста и комментариев
				 */
				if ($access['view_post'] && ($allow_comments || $post_data['privacy_comments'] == BLOG_COMMENTS_DISABLE)) {
					break;
				}
				
				/**
				 * Поиск среди друзей
				 */
				if ($post_data['privacy_post'] == BLOG_POST_FRIENDS || $post_data['privacy_post'] == BLOG_POST_F_FRIENDS) {
					if (is_friend($user_id, $post_data['user_id'])) {
						$allow_comments = $allow_comments || $post_data['privacy_post'] != BLOG_COMMENTS_DISABLE;
						break;
					}
				}
				
				if ($post_data['privacy_post'] == BLOG_POST_F_FRIENDS && is_f_friend($user_id, $post_data['user_id'])) {
					$allow_comments = $allow_comments || $post_data['privacy_comments'] == BLOG_COMMENTS_F_FRIENDS;
					break;
				}
			}
			
			/**
			 * Просмотр открыт для всех
			 */
			if ($post_data['privacy_post'] == BLOG_POST_USERS) {
				break;
			}
			
			echo '<p>' . "\n";
			echo 'Вы не можете просматривать эту запись';
			echo '</p>' . "\n";
			
			close($theme);
		} while (0);
	}
	
	/**
	 * Отображение поста
	 */
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Просмотр записи "' . $post_data['post_title'] . '"' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Тема:<br />' . "\n";
	echo $post_data['post_title'] . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Дата создания:<br />' . "\n";
	echo fdate($post_data['post_add_time']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Автор:<br />' . "\n";
	echo '<a href="../profile.php?user=' . $post_data["user_id"] . '">' . $post_data['user_login'] . '</a>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Сообщение:<br />' . "\n";
	echo tags($post_data['post_text']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if ($post_data['post_edit_time']) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Последнее изменение:<br />' . "\n";
		echo fdate($post_data['post_edit_time']) . ', ';
		echo '<a href="../profile.php?user=' . $post_data['post_edit_user_id'] . '">' . $post_data['post_edit_user_login'] . '</a>';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	
	$tags = explode(', ', $post_data['post_tags']);
	$tags_with_url = array();
	
	if (count($tags)) {
		foreach ($tags as $tag) {
			$tags_with_url[] = '<a href="tag.php?tag=' . urlencode($tag) . '">' . $tag . '</a>';
		}
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Метки:<br />' . "\n";
		echo implode(', ', $tags_with_url) . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '</table>' . "\n";
	
	/**
	 * Похожие публикации
	 */
	$sql = 'select p.*, b.blog_name , u.user_login
	from ' . BLOG_TAGS_TABLE . ' as t 
	inner join ' . BLOG_POSTS_TABLE . ' as p using (post_id) 
	left join ' . BLOGS_TABLE .' as b on (b.blog_id = p.blog_id) 
	left join ' . USERS_TABLE .' as u on (u.user_id = p.user_id) 
	where post_id <> ' . $post_id . ' and post_tag in ("' . implode('", "', $tags) . '") 
	group by p.post_id
	order by p.post_add_time desc limit 10';
	
	$query = mysql_query($sql);
	
	if (mysql_num_rows($query)) {
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Похожие публикации' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			
			if ($fields['blog_id']) {
				echo 'Блог <a href="index.php?blog=' . $fields['blog_id'] . '">' . $fields['blog_name'] . '</a> &rarr; ';
			} else {
				echo 'Блог им. <a href="../profile.php?user=' . $fields['user_id'] . '">' . $fields['user_login']  . '</a> &rarr; ';
			}
			
			echo '<a href="post.php?post=' . $fields['post_id'] . '">' . $fields['post_title'] . '</a>';
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
	}
	
	if ($allow_comments) {
		echo '<p>' . "\n";
		echo '<a href="comments.php?post=' . $post_id . '">Обсуждение (' . $post_data['post_count_comments'] . ')</a>' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($access['edit_post']) {
		echo '<p>' . "\n";
		echo '<a href="editpost.php?post=' . $post_id . '">Редактировать запись</a>' . "\n";
		echo '</p>' . "\n";
	}
	
	if ($access['delete_post']) {
		echo '<p>' . "\n";
		echo '<a href="post.php?delete&amp;post=' . $post_id . '">Удалить запись</a>' . "\n";
		echo '</p>' . "\n";
	}
}

close($theme);
?>