<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('ONLY_LOGGED', 1);
define('PAGE', 'privmsgs.php');
define('TIME', microtime());

require ('wb-includes/common.php');
require ('wb-includes/plugins/friends.php');

if (isset($_GET['read'], $_GET['folder'], $_GET['id']) && is_unsigned($_GET['id'], true)) {
	/**
	 * Чтение сообщения
	 */
	
	$theme = array (
		'Приватные сообщения',
		'Чтение сообщения',
		'<a href="privmsgs.php">Приватная почта</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$folder = $_GET['folder'] == 'inbox' ? 0 : 1;
	$table  = $folder ? PRIVMSGS_OUT_TABLE : PRIVMSGS_IN_TABLE;
	$where  = $folder ? 'to' : 'from';
	
	$sql = 'select p.*, u.user_login 
	from ' . $table . ' as p 
	left join ' . USERS_TABLE . ' as u on (p.privmsgs_user_id_' . $where . ' = u.user_id) 
	where p.privmsgs_id = ' . $_GET['id'] . ' 
	and p.privmsgs_user_id = ' . $user_id;
	
	$query = mysql_query($sql);
	$fields = mysql_fetch_array($query);
	
	if (!$fields) {
		redirect('privmsgs.php?inbox');
	}
	
	/**
	 * Отправка отчета о прочтении
	 */
	if ($fields['privmsgs_read'] == 0 && $folder == 0) {
		$sql_1 = 'update ' . PRIVMSGS_IN_TABLE . ' set privmsgs_read = "1" 
		where privmsgs_id = ' . $fields['privmsgs_id'];
		
		$sql_2 = 'update ' . PRIVMSGS_OUT_TABLE . ' set privmsgs_read = "1" 
		where privmsgs_user_id = ' . $fields['privmsgs_user_id_from'] . ' 
		and privmsgs_time = ' . $fields['privmsgs_time'];
		
		mysql_query($sql_1);
		mysql_query($sql_2);
		
		update_unread_privmsgs($user_id);
	}
	
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Чтение сообщения' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Тема:<br />' . "\n";
	echo $fields['privmsgs_subject'] . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	if ($folder) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Для:<br /><a href="profile.php?user=' . $fields['privmsgs_user_id_to'] . '">' . $fields['user_login'] . '</a><br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Когда:<br />' . "\n";
		echo fdate($fields['privmsgs_time']) . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	} else {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Автор:<br />' . "\n";
		echo '<a href="profile.php?user=' . $fields['privmsgs_user_id_from'] . '">' . $fields['user_login'] . '</a><br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Когда:<br />' . "\n";
		echo fdate($fields['privmsgs_time']) . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Сообщение:<br />' . "\n";
	echo tags($fields['privmsgs_message']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>';
	
	if ($folder) {
		echo '<p>' . "\n";
		echo '<a href="privmsgs.php?write&amp;user=' . $fields['privmsgs_user_id_to']  . '">Написать</a>' . "\n";
		echo '</p>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo '<a href="privmsgs.php?repty&amp;id=' . $fields['privmsgs_id'] . '">Ответить</a>' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_GET['inbox'])) {
	/**
	 * Входящие
	 */
	
	$theme = array (
		'Приватная почта',
		'Входящие сообщения',
		'<a href="privmsgs.php">Приватная почта</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select count(*) FROM ' . PRIVMSGS_IN_TABLE . ' 
	where privmsgs_user_id = ' . $user_id;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select p.*, u.user_login 
		from ' . PRIVMSGS_IN_TABLE . ' as p 
		left join ' . USERS_TABLE . ' as u on p.privmsgs_user_id_from = u.user_id 
		where p.privmsgs_user_id = ' . $user_id . ' 
		order by p.privmsgs_id desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		echo '<form action="privmsgs.php" method="post">' . "\n";
		echo '<input type="hidden" name="folder" value="inbox" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Входящие сообщения' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_array($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="checkbox" name="id[]" value="' . $fields['privmsgs_id'] . '" /> ';
			echo '<a href="privmsgs.php?read&amp;folder=inbox&amp;id=' . $fields['privmsgs_id'] . '">' . $fields['privmsgs_subject'] . '</a> ';
			echo 'от <a href="profile.php?user=' . $fields['privmsgs_user_id_from'] . '">' . $fields['user_login'] . '</a> ';
			echo '(' . fdate($fields['privmsgs_time']) . ')' . "\n";
			echo $fields['privmsgs_read'] ? '' : ' (Непрочитанно)';
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		echo '<p>' . "\n";
		echo '<input type="submit" name="delete" value="Удалить" /> ' . "\n";
		echo '<input type="submit" name="delete_read" value="Удалить прочитанные" /> ' . "\n";
		echo '<input type="submit" name="delete_all" value="Удалить все" /> ' . "\n";
		echo '</p>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего сообщений: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'privmsgs.php?inbox&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
		
		echo '</form>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo 'Сообщений нет' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_GET['outbox'])) {
	/**
	 * Исходящие
	 */
	
	$theme = array (
		'Приватная почта',
		'Исходящие сообщения',
		'<a href="privmsgs.php">Приватная почта</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select count(*) from ' . PRIVMSGS_OUT_TABLE . '
	where privmsgs_user_id = ' . $user_id;
	
	$query = mysql_query($sql);
	$count = mysql_result($query, 0);
	
	if ($count) {
		$pagination = pagination_main($count, get_nav_posts());
		
		$sql = 'select p.*, u.user_login 
		from ' . PRIVMSGS_OUT_TABLE . ' as p 
		left join ' . USERS_TABLE . ' as u on (p.privmsgs_user_id_to = u.user_id) 
		where p.privmsgs_user_id = ' . $user_id . ' 
		order by p.privmsgs_id desc 
		limit ' . $pagination['start'] . ', ' . $pagination['end'];
		
		$query = mysql_query($sql);
		
		echo '<form action="privmsgs.php" method="post">' . "\n";
		echo '<input type="hidden" name="folder" value="outbox" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Исходящие сообщения' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		while ($fields = mysql_fetch_assoc($query)) {
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo '<input type="checkbox" name="id[]" value="' . $fields['privmsgs_id'] . '" /> ';
			echo '<a href="privmsgs.php?read&amp;folder=outbox&amp;id=' . $fields['privmsgs_id'] . '"';
			echo ($fields['privmsgs_read'] ? '' : ' id="unread"') . '>' . $fields['privmsgs_subject'] . '</a> ';
			echo 'для <a href="profile.php?user=' . $fields['privmsgs_user_id_to'] . '">' . $fields['user_login'] . '</a> ';
			echo '(' . fdate($fields['privmsgs_time']) . ')' . "\n";
			echo $fields['privmsgs_read'] ? '' : ' (Непрочитанно)';
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
		}
		
		echo '</table>' . "\n";
		echo '<p>' . "\n";
		echo '<input type="submit" name="delete" value="Удалить" /> ' . "\n";
		echo '<input type="submit" name="delete_all" value="Удалить все" /> ' . "\n";
		echo '</p>' . "\n";
		
		if ($pagination['all_pages'] > 1) {
			echo '<p>' . "\n";
			echo 'Всего сообщений: ' . $count . '<br />' . "\n";
			echo 'Страницы: ' . pagination_links($pagination['all_pages'], $pagination['page'], 'privmsgs.php?outbox&amp;page=%d') . "\n";
			echo '</p>' . "\n";
		}
		
		echo '</form>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo 'Сообщений нет' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_GET['repty'], $_GET['id']) && is_unsigned($_GET['id'], true)) {
	/**
	 * Ответ на сообщение
	 */
	
	$theme = array (
		'Приватные сообщения',
		'Ответ на сообщение',
		'<a href="privmsgs.php">Приватная почта</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	
	$sql = 'SELECT p.privmsgs_user_id_from as user_id, p.privmsgs_subject as subject 
	from ' . PRIVMSGS_IN_TABLE . ' as p 
	inner join ' . USERS_TABLE . ' as u on (u.user_id = p.privmsgs_user_id_from) 
	where p.privmsgs_id = ' . $_GET['id'] . ' and p.privmsgs_user_id = ' . $user_id;
	
	$query = mysql_query($sql);
	$fields = mysql_fetch_assoc($query);
	
	if (!$fields) {
		redirect('privmsgs.php?write');
	}
	
	if (preg_match('/^re\[[\d]+\]\:/i', $fields['subject'])) {
		$subject = preg_replace('/^re\[(.*[\d]+)]\:/ie', '"RE[" . (\\1+1) . "]:"', $fields['subject']);
	} elseif (preg_match('/^re\:/i', $fields['subject'])) {
		$subject = preg_replace('/^re\:/i', 'RE[1]:', $fields['subject']);
	} else {
		$subject = 'RE: ' . $fields['subject'];
	}
	
	/**
	 * Антифлуд
	 */
	if (($wait = antiflood())) {
		echo '<p><span id="info">' . "\n";
		echo 'Действие антифлуда закончится через ' . $wait . ' ' . declension($wait, array('секунду', 'секунды', 'секунд'));
		echo '</span></p>' . "\n";
	}
	
	echo '<form enctype="multipart/form-data" action="privmsgs.php" method="post">' . "\n";
	echo '<input type="hidden" name="user" value="' . $fields['user_id'] . '" />' . "\n";
	echo '<input type="hidden" name="send" />' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Отправка приватного сообщения' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Тема:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('privmsgs_length_subject') . ' символов</span><br />' . "\n";
	echo '<input type="text" name="subject" value="' . $subject . '" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Сообщение:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('privmsgs_length_message') . ' символов</span><br />' . "\n";
	echo '<textarea name="message" ' . get_option('textarea_attributes') . '></textarea>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	/**
	 * Транслит
	 */
	if ($user_data['user_allow_translit']) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<input type="checkbox" name="translit_subject" value="1" /> Транслит темы<br />' . "\n";
		echo '<input type="checkbox" name="translit_message" value="1" /> Транслит сообщения' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo '<input type="checkbox" name="save" value="1" checked="checked" /> Сохранить сообщение<br />' . "\n";
	echo '<input type="submit" value="Отправить" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";

} elseif (isset($_REQUEST['write'])) {
	/**
	 * Написание приватногоо сообщения
	 */
	
	$theme = array (
		'Приватная почта',
		'Отправка приватного сообщения',
		'<a href="privmsgs.php">Приватная почта</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	
	/**
	 * Передача Id пользователя GET'ом
	 */
	$user = false;
	
	if (isset($_REQUEST['user']) && is_unsigned($_REQUEST['user'])) {
		$sql = 'select user_id, user_login from ' . USERS_TABLE . '
		where user_id = ' . $_REQUEST['user'];
		
		$query = mysql_query($sql);
		$user = mysql_fetch_assoc($query);
	}
	
	/**
	 * Антифлуд
	 */
	if (($wait = antiflood())) {
		echo '<p><span id="info">' . "\n";
		echo 'Действие антифлуда закончится через ' . $wait . ' ' . declension($wait, array('секунду', 'секунды', 'секунд'));
		echo '</span></p>' . "\n";
	}
	
	echo '<form enctype="multipart/form-data" action="privmsgs.php" method="post">' . "\n";
	echo '<table ' . get_option('table_attributes') . '>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="title">' . "\n";
	echo 'Отправка приватного сообщения' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Логин или ID:<br />' . "\n";
	
	echo $user ? '<input type="hidden" name="user" value="' . $user['user_id'] . '" />' . "\n" : '';
	echo '<input type="text" ' . ($user ? 'name="user_disable" value="' . $user['user_login'] . '" disabled="disabled"' : 'name="user" value=""') . ' /><br />' . "\n";
	
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Тема:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('privmsgs_length_subject') . ' символов</span><br />' . "\n";
	echo '<input type="text" name="subject" value="' . ($user ? sprintf(get_option('privmsgs_default_subject'), $user['user_login']) : '') . '" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Сообщение:<br />' . "\n";
	echo '<span id="info">Не более ' . get_option('privmsgs_length_message') . ' символов</span><br />' . "\n";
	echo '<textarea name="message" ' . get_option('textarea_attributes') . '></textarea>' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	
	/**
	 * Транслит
	 */
	if ($user_data['user_allow_translit']) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<input type="checkbox" name="translit_subject" value="1" /> Транслит темы<br />' . "\n";
		echo '<input type="checkbox" name="translit_message" value="1" /> Транслит сообщения' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	}
	
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo '<input type="checkbox" name="save" value="1" checked="checked" /> Сохранить сообщение<br />' . "\n";
	echo '<input type="submit" name="send" value="Отправить" />' . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
	echo '</table>' . "\n";
	echo '</form>' . "\n";
} elseif (isset($_POST['send'], $_POST['user'], $_POST['subject'], $_POST['message'])) {
	/**
	 * Отправка сообщения
	 */
	
	$theme = array (
		'Приватная почта',
		'Отправка приватного сообщения',
		'<a href="privmsgs.php">Приватная почта</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	$sql = 'select user_id, user_privmsgs_privacy from ' . USERS_TABLE . ' 
	where ' . (is_unsigned($_POST['user'], true) ? 'user_id' : 'user_login')  . ' = "' . mysql_escape_string(check($_POST['user'])) . '"';
	
	$query = mysql_query($sql);
	$user = mysql_fetch_assoc($query);
	
	/**
	 * Неправославно самому себе сообщения отсылать =P
	 */
	if ($user_id == $user["user_id"]) {
		redirect('privmsgs.php');
	}
	
	$subject = cut(check($_POST['subject']), get_option('length_privmsgs_subject'));
	$subject = isset($_POST['translit_subject']) ? translit($subject) : $subject;
	
	$message = cut(check($_POST['message'], true), get_option('length_privmsgs_message'));
	$message = isset($_POST['translit_message']) ? translit($message) : $message;
	
	if ($user && $subject && $message) {
		/**
		 * Приватность отправки
		 */
		if ($user['user_privmsgs_privacy'] != PRIVMSGS_USERS && !is_friend($user_id, $user['user_id'])) {
			if ($user['user_privmsgs_privacy'] == PRIVMSGS_FRIENDS) {
				echo '<p>' . "\n";
				echo 'Этому пользователю могут написать сообщение только его друзья' . "\n";
				echo '</p>' . "\n";
				
				close($theme);
				
			} elseif (!is_f_friend($user_id, $user['user_id'])) {
				echo '<p>' . "\n";
				echo 'Этому пользователю могут написать сообщение его друзья или друзья друзей.' . "\n";
				echo '</p>' . "\n";
				
				close($theme);
			}
		}
		
		$user = $user['user_id'];
		
		/**
		 * Антифлуд
		 */
		if (($wait = antiflood())) {
			$expressions = array('секунду', 'секунды', 'секунд');
			
			echo '<p>' . "\n";
			echo 'Нельзя писать чаще чем раз в ' . get_option('flood_time') . ' ' . declension(get_option('flood_time'), $expressions) . '.<br />' . "\n";
			echo 'Подождите еще ' . $wait . ' ' . declension($wait, $expressions) . ', а потом <a href="privmsgs.php?write&amp;user=' . $user . '">напишите снова</a>' . "\n";
			echo '</p>' . "\n";
			
			close($theme);
		}
		
		/**
		 * Проверка квоты
		 */
		if (!$is_admin && get_option('privmsgs_quota') != -1) {
			$time = microtime();
			
			$sql = 'select count(*) from %s where privmsgs_user_id = %u';
			$count = mysql_result(mysql_query(sprintf($sql, PRIVMSGS_IN_TABLE, $user)), 0);
			$count += mysql_result(mysql_query(sprintf($sql, PRIVMSGS_OUT_TABLE, $user)), 0);
			
			if (get_option('privmsgs_quota') <= $count) {
				echo '<p>' . "\n";
				echo 'Отправка сообщения данному пользователю невозможна!<br />' . "\n";
				echo 'Количество сохраненных сообщений пользователя достигло предела ';
				echo '(' . get_option('privmsgs_quota') . ' ' . declension(get_option('privmsgs_quota'), array('сообщение', 'сообщения', 'сообщений')) . ')' . "\n";
				echo '</p>' . "\n";
			  
				close($theme);
			}
			
			if (isset($_POST['save'])) {
				$count = mysql_result(mysql_query(sprintf($sql, PRIVMSGS_IN_TABLE, $user_id)), 0);
				$count += mysql_result(mysql_query(sprintf($sql, PRIVMSGS_OUT_TABLE, $user_id)), 0);
				
				if (get_option('privmsgs_quota') <= $count) {
					unset($_POST['save']);
				}
			}
		}
		
		/**
		 * Запись сообщения для адресата и отправителя (если нужно сохранить)
		 */
		$sql = 'insert into ' . PRIVMSGS_IN_TABLE . ' (
		privmsgs_user_id,
		privmsgs_user_id_from,
		privmsgs_read,
		privmsgs_time,
		privmsgs_subject,
		privmsgs_message
		) values (
		' . $user . ',
		' . $user_id . ',
		"0",
		' . time() . ',
		"' . mysql_escape_string($subject) . '",
		"' . mysql_escape_string($message) . '"
		)';
		
		mysql_query($sql);
		
		if (isset($_POST['save'])) {
			$sql = 'insert into ' . PRIVMSGS_OUT_TABLE . ' (
			privmsgs_user_id,
			privmsgs_user_id_to,
			privmsgs_read,
			privmsgs_time,
			privmsgs_subject,
			privmsgs_message
			) values (
			' . $user_id . ',
			' . $user . ',
			"0",
			' . time() . ',
			"' . mysql_escape_string($subject) . '",
			"' . mysql_escape_string($message) . '"
			)';
			
			mysql_query($sql);
		}
		
		update_unread_privmsgs($user);
		update_antiflood();
		
		echo '<p>' . "\n";
		echo 'Сообщение отправлено<br />' . "\n";
		echo '<a href="privmsgs.php?write">Написать еще</a> ' . "\n";
		echo '<a href="privmsgs.php?write&amp;user=' . $user . '">тому же пользователю</a>' . "\n";
		echo '</p>' . "\n";
	} else if (!$user) {
		echo '<p>' . "\n";
		echo 'Пользователь не найден<br />' . "\n";
		echo '<a href="privmsgs.php?write">Ввести заново</a>' . "\n";
		echo '</p>' . "\n";
	} else {
		echo '<p>' . "\n";
		echo 'Не введены тема и/или сообщение<br />' . "\n";
		echo '<a href="privmsgs.php?write">Ввести заново</a>' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_POST['delete']) && isset($_POST['folder'])) {
	/**
	 * Удаление указанных сообщений
	 */
	if (isset($_POST['id']) && is_array($_POST['id'])) {
		foreach ($_POST['id'] as $i) {
			if (is_unsigned($i, true)) {
				$id[] = $i;
			}
		}
		
		if (count($id)) {
			$sql = 'delete from ' . ($_POST['folder'] == 'inbox' ? PRIVMSGS_IN_TABLE : PRIVMSGS_OUT_TABLE) . ' 
			where privmsgs_user_id = ' . $user_id . ' 
			and privmsgs_id in (' .  implode(', ', array_unique($id)) . ')';
			
			mysql_query($sql);
		}
	}
	
	update_unread_privmsgs($user_id);
	redirect('privmsgs.php');
	
} elseif (isset($_POST['delete_read'])) {
	/**
	 * Удаление прочитанных входящих сообщений
	 */
	
	$sql = 'delete from ' . PRIVMSGS_IN_TABLE . ' 
	where privmsgs_user_id = ' . $user_id . ' 
	and privmsgs_read = "1"';
	
	mysql_query($sql);
	redirect('privmsgs.php');
	
} elseif (isset($_POST['delete_all'])) {
	/**
	 * Удаление всех сообщений
	 */
	
	$sql = 'delete from %s
	where privmsgs_user_id = ' . $user_id;
	
	if (isset($_POST['folder'])) {
		mysql_query(sprintf($sql, $_POST['folder'] == 'inbox' ? PRIVMSGS_IN_TABLE : PRIVMSGS_OUT_TABLE));
		
		if ($_POST['folder'] == 'inbox') {
			update_unread_privmsgs($user_id);
		}
	} else {
		mysql_query(sprintf($sql, PRIVMSGS_IN_TABLE));
		mysql_query(sprintf($sql, PRIVMSGS_OUT_TABLE));
	}
	
	redirect('privmsgs.php');
} else {
	$theme = array (
	  'Приватная почта', 
	  'Приватная почта', 
	  '<a href="index.php">На главную</a>'
	);
	
	$sql = 'select count(*), (select count(*) from ' . PRIVMSGS_OUT_TABLE . ' where privmsgs_user_id = ' . $user_id . ' ) 
	from ' . PRIVMSGS_IN_TABLE . ' where privmsgs_user_id = ' . $user_id;
	
	list($count_in, $count_out) = mysql_fetch_row(mysql_query($sql));
	
	echo '<p>' . "\n";
	echo '<a href="privmsgs.php?inbox">Входящие</a> (' . $count_in . ')<br />' . "\n";
	echo '<a href="privmsgs.php?outbox">Исходящие</a> (' . $count_out . ')<br />' . "\n";
	echo '<a href="privmsgs.php?write">Отправить сообщение</a>' . "\n";
	echo '</p>' . "\n";
}

close($theme);
?>