<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('PAGE', 'profile.php');
define('TIME', microtime());

require('wb-includes/common.php');
require('wb-includes/plugins/friends.php');

$user_info = $is_logged ? $user_data : array();

if (isset($_REQUEST['user'])) {
	$user = preg_replace('/[^A-z0-9\-_]/', '', $_REQUEST['user']);
	
	$sql = 'select * from ' . USERS_TABLE . ' 
	where ' . (is_unsigned($user) ? 'user_id' : 'user_login') . ' = "' . $user . '"';
	
	if (($query = mysql_query($sql)) && mysql_num_rows($query)) {
		$user_info = mysql_fetch_assoc($query);
	}
} elseif (!$is_logged) {
	redirect('register.php?redirect=' . PAGE);
}

echo '<table ' . get_option('table_attributes') . '>' . "\n";
echo '<tr>' . "\n";
echo '<td id="title">' . "\n";
echo 'Профиль' . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Пользователь #' . $user_info['user_id'] . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Логин:<br />' . "\n";
echo $user_info['user_login'] . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

if ($user_info['user_status']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Статус на сайте:<br />' . "\n";
	echo $user_info['user_status'] . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if (is_file('wb-content/avators/' . $user_info['user_id'] . '.png')) {
	$config_image = getimagesize('wb-content/avators/' . $user_info['user_id'] . '.png');
	
	if ($config_image) {
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo '<img src="wb-content/avators/' . $user_info['user_id'] . '.png" ' . $config_image[3] . ' alt="Аватор" /><br />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
	} else {
		unlink('wb-content/avator/' . $user_info['user_id'] . '.png');
	}
}

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Регистрация:<br />' . "\n";
echo fdate($user_info['user_register']) . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Последний визит:<br />' . "\n";
echo fdate($user_info['user_last_visit']) . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Пол:<br />' . "\n";
echo get_option($user_info['user_sex'] == 'm' ? 'man' : 'woman') . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";


if ($user_info['user_email_privacy']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'E-mail:<br />' . "\n";
	echo $user_info['user_email'] . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_name']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Имя:<br />' . "\n";
	echo  tags($user_info['user_name']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_surname']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Фамилия:<br />' . "\n";
	echo tags($user_info['user_surname']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_about']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'О себе:<br />' . "\n";
	echo tags($user_info['user_about']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_interests']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Интересы:<br />' . "\n";
	echo tags($user_info['user_interests']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_phone']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'Телефон:<br />' . "\n";
	echo tags($user_info['user_phone']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_im']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'IM (ICQ, Jabber, MRA..):<br />' . "\n";
	echo $user_info['user_im'] . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

if ($user_info['user_url']) {
	echo '<tr>' . "\n";
	echo '<td id="text">' . "\n";
	echo 'URL:<br />' . "\n";
	echo tags($user_info['user_url']) . "\n";
	echo '</td>' . "\n";
	echo '</tr>' . "\n";
}

$sql = 'select count(*) from ' . BLOG_COMMENTS_TABLE . ' where user_id = ' . $user_info['user_id'];
$count_comments = mysql_result(mysql_query($sql), 0);

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Всего записей: <a href="blogs/index.php?user=' . $user_info['user_id'] . '&amp;all">' . $user_info['user_count_posts'] . '</a><br />' . "\n";
echo 'Всего комментариев: <a href="blogs/comments.php?user=' . $user_info['user_id'] . '">' . $user_info['user_count_comments'] . '</a>' . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";


/**
 * Участие в группах
 */
$sql = 'select g.group_id, g.group_name 
from ' . GROUP_USER_TABLE . ' as gu 
inner join ' . GROUPS_TABLE . ' AS g using (group_id) 
where gu.user_id = ' . $user_info['user_id'] . ' 
order by g.group_name asc';

$groups = array();
$query = mysql_query($sql);

while ($rows = mysql_fetch_row($query)) {
	$groups[] = '<a href="groups.php?group=' . $rows[0] . '">' . $rows[1] . '</a>';
}

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Участие в группах:<br />' . "\n";
echo (count($groups) ? implode(' &#x25AA; ', $groups) : 'нет') . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

/**
 * Участие в коллективных блогах
 */
$sql = 'select b.blog_id, b.blog_name 
from ' . BLOGS_USER_TABLE . ' as bu 
inner join ' . BLOGS_TABLE . ' AS b using (blog_id) 
where bu.user_id = ' . $user_info['user_id'] . ' 
order by b.blog_name asc';

$blogs = array();
$query = mysql_query($sql);

while ($rows = mysql_fetch_row($query)) {
	$blogs[] = '<a href="blogs/blogs.php?blog=' . $rows[0] . '">' . $rows[1] . '</a>';
}

echo '<tr>' . "\n";
echo '<td id="text">' . "\n";
echo 'Участие в коллективных блогах:<br />' . "\n";
echo (count($blogs) ? implode(' &#x25AA; ', $blogs) : 'нет') . "\n";
echo '</td>' . "\n";
echo '</tr>' . "\n";

echo '</table>' . "\n";

if ($is_logged) {
	if ($user_info['user_id'] != $user_id) {
		$is_friend = is_friend($user_id, $user_info['user_id']);
		
		/**
		 * Друг друга?
		 */
		if (!$is_friend && ($user_info['user_friends_privacy'] == FRIENDS_F_FRIENDS || $user_info['user_privmsgs_privacy'] == PRIVMSGS_F_FRIENDS || $user_info['user_wall_privacy'] == WALL_F_FRIENDS)) {
			$is_f_friend = is_f_friend($user_id, $user_info['user_id']);
		}
		
		do {
			if ($user_info['user_friends_privacy'] == FRIENDS_ME) {
				break;
			}
			
			if ($user_info['user_friends_privacy'] == FRIENDS_FRIENDS && !$is_friend) {
				break;
			}
			
			if ($user_info['user_friends_privacy'] == FRIENDS_F_FRIENDS && !$is_friend && !$is_f_friend) {
				break;
			}
			echo '<p>' . "\n";
			echo '<a href="friends.php?user=' . $user_info['user_id'] . '">Друзья пользователя</a>' . "\n";
			echo '</p>' . "\n";
		}
		while(0);
		
		if (!$is_friend && $user_info['user_friendship_privacy'] != FRIENDSHIP_DISABLE) {
			echo '<p>' . "\n";
			echo '<a href="friends.php?add&amp;user=' . $user_info['user_id'] . '">Добавить в друзья</a>' . "\n";
			echo '</p>' . "\n";
		}
		
		do {
			if ($user_info['user_wall_privacy'] == WALL_ME) {
				break;
			}
			
			if ($user_info['user_wall_privacy'] == WALL_FRIENDS && !$is_friend) {
				break;
			}
			
			if ($user_info['user_wall_privacy'] == WALL_F_FRIENDS && !$is_friend && !$is_f_friend) {
				break;
			}
			
			echo '<p>' . "\n";
			echo '<a href="wall.php?user=' . $user_info['user_id'] . '">Стена пользователя</a><br />' . "\n";
			echo '</p>' . "\n";
		}
		while(0);
		
		do {
			if (!$is_admin) {
				if ($user_info['user_privmsgs_privacy'] == PRIVMSGS_FRIENDS && !$is_friend) {
					break;
				}
				
				if ($user_info['user_privmsgs_privacy'] == PRIVMSGS_F_FRIENDS && !$is_friend && !$is_f_friend) {
					break;
				}
			}
			
			echo '<p>' . "\n";
			echo '<a href="privmsgs.php?write&amp;user=' . $user_info['user_id'] . '">Приватное сообщение</a><br />' . "\n";
			echo '</p>' . "\n";
		}
		while(0);
		
		if ($is_admin) {
			echo '<p>' . "\n";
			echo '<a href="wb-admin/admin_profiles.php?edit&amp;user=' . $user_info['user_id'] . '">Редактировать профиль</a><br />' . "\n";
			echo '<a href="wb-admin/admin_profiles.php?delete&amp;user=' . $user_info['user_id'] . '">Удалить профиль</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<p>' . "\n";
		echo '<a href="usercp.php?profile">Редактировать профиль</a>' . "\n";
		echo '</p>' . "\n";
	}
}

close('Профиль', 'Профиль', '<a href="index.php">На главную</a>');
?>