<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
define('IN_WBENGINE', 1);
define('ONLY_LOGGED', 1);
define('PAGE', 'usercp.php');
define('TIME', microtime());

require('wb-includes/common.php');

if (isset($_REQUEST['password'])) {
	/**
	 * Изменение пароля
	 */
	
	$theme = array(
		'Изменение пароля',
		'Изменение пароля',
		'<a href="usercp.php">Кабинет</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	if (isset($_POST['password'], $_POST['new_password'])) {
		$new_password = $_POST['new_password'];
		$errors = array();
		
		if (md5(md5($_POST['password'])) != $user_data['user_password']) {
			$errors[] = 'Неверно указан текущий пароль';
		}
		
		if (!preg_match('/^[A-z0-9]+$/', $new_password)) {
			$errors[] = 'В новом пароле недопустимые символы';
		}
		
		if (($lenght = strlen($new_password)) > 25) {
			$errors[] = 'Длина нового пароля более 25 символов';
		}
		
		if (count($errors)) {
			echo '<table ' . get_option('table_attributes') . '>' . "\n";
			echo '<tr>' . "\n";
			echo '<td id="title">' . "\n";
			echo 'Изменение пароля' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			echo '<tr>' . "\n";
			echo '<td id="text">' . "\n";
			echo 'В Вашем запросе найдены ошибки:<br />' . "\n";
			
			foreach ($errors as $err) {
				echo $err . '<br />' . "\n";
			}
			
			echo '<a href="usercp.php?password">Ввести заново</a>' . "\n";
			echo '</td>' . "\n";
			echo '</tr>' . "\n";
			echo '</table>' . "\n";
		} else {
			$password = md5(md5($new_password));
			$_SESSION['user_pass'] = $new_password;
			
			$cookies = array (
				$_SESSION['user_id'],
				$_SESSION['user_password']
			);
			
			setcookie('cookies_data', base64_encode(serialize($cookies)), time() + 31536000);
			
			$sql = 'update ' . USERS_TABLE . ' set 
			user_password = "' . $password . '" where user_id = ' . $user_id;
			
			mysql_query($sql);
			
			echo '<p>' . "\n";
			echo 'Пароль изменен!<br />' . "\n";
			echo 'При следующей авторизации вводите указанный пароль' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<form action="usercp.php" method="post">' . "\n";
		echo '<input type="hidden" name="password" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Изменение пароля' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Текущий пароль:<br />' . "\n";
		echo '<span id="info">Для смены пароля необходимо ввести текущий пароль</span><br />';
		echo '<input type="password" name="password" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Новый пароль:<br />' . "\n";
		echo '<span id="info">Длина пароля не более 25 символов<br />' . "\n";
		echo 'Только английские буквы и цифры</span><br />' . "\n";
		echo '<input type="password" name="new_password" maxlength="25" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" value="Изменить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	}
} elseif (isset($_REQUEST['profile'])) {
	/**
	 * Изменение данных профиля
	 */
	
	$theme = array (
		'Профиль',
		'Профиль',
		'<a href="usercp.php">Кабинет</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	if (!isset($_POST['submit'])) {
		/**
		 * Форма для изменения данных
		 */
		echo '<form action="usercp.php" method="post">' . "\n";
		echo '<input type="hidden" name="profile" />' . "\n";
		echo '<input type="hidden" name="submit" />' . "\n";
		
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Профиль' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Ваш пол:<br />' . "\n";
		echo '<input type="radio" name="sex" value="m" ' . ($user_data['user_sex'] != 'f' ? 'checked="checked" ' : '') . '/>' . get_option('man') . '<br />' . "\n";
		echo '<input type="radio" name="sex" value="f" ' . ($user_data['user_sex'] == 'f' ? 'checked="checked" ' : '') . '/>' . get_option('woman') . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'E-mail:<br />' . "\n";
		echo '<span id="info">Не более 80 символов</span><br />' . "\n";
		echo '<input type="text" name="email"  value="' . $user_data['user_email'] . '" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Имя:<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_name') . ' символов</span><br />' . "\n";
		echo '<input type="text" name="name"  value="' . $user_data['user_name'] . '" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Фамилия:<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_surname') . ' символов</span><br />' . "\n";
		echo '<input type="text" name="surname"  value="' . $user_data['user_surname'] . '" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'IM (ICQ, Jabber, MSN..):<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_im') . ' символов</span><br />' . "\n";
		echo '<input type="text" name="im" value="' . $user_data['user_im'] . '" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Домашняя страничка:<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_url') . ' символов</span><br />' . "\n";
		echo '<input type="text" name="url" value="' . $user_data['user_url'] . '" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Телефон:<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_phone') . ' символов</span><br />' . "\n";
		echo '<input type="text" name="phone" value="' . $user_data['user_phone'] . '" />';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Немного о себе:<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_about') . ' символов</span><br />' . "\n";
		echo '<textarea name="about" ' . get_option('textarea_attributes') .'>' . $user_data['user_about'] . '</textarea>';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		echo 'Интересы:<br />' . "\n";
		echo '<span id="info">Не более ' . get_option('length_interests') . ' символов</span><br />' . "\n";
		echo '<textarea name="interests" ' . get_option('textarea_attributes') .'>' . $user_data['user_interests'] . '</textarea>';
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" value="Изменить" /> ' . "\n";
		echo '<input type="submit" name="reset" value="Сброс" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		
		echo '</table>' . "\n";
		echo '</form>' . "\n";
	} else {
		/**
		 * СОхраенине изменений
		 */
		if (isset($_POST['reset'])) {
			$sex = 'm';
			$email = $user_data['user_email'];
			$name = $surname = $phone = $im = $url = $about = $interests = '';
		} else {
			$sex = !empty($_POST['sex']) ? $_POST['sex'] : 'm';
			$sex = $sex == 'm' || $sex == 'f' ? $sex : 'm';
			
			$email = !empty($_POST['email']) ? $_POST['email'] : '';
			$email = strlen($email) < 80 && preg_match("/^[\.A-z0-9_\-]+[@][A-z0-9_\-]+([.][A-z0-9_\-]+)+[A-z]{1,4}$/", $email) ? $email : $user_data['user_email'];
			
			if (!empty($_POST['name'])) {
				$name = check(cut($_POST['name'], get_option('length_name')));
				$name = mysql_escape_string($name);
			} else {
				$name = '';
			}
			
			if (!empty($_POST['surname'])) {
				$surname = check(cut($_POST['surname'], get_option('length_surname')));
				$surname = mysql_escape_string($surname);
			} else {
				$surname = '';
			}
			
			if (!empty($_POST['phone'])) {
				$phone = check(cut($_POST['phone'], get_option('length_phone')));
				$phone = mysql_escape_string($phone);
			} else {
				$phone = '';
			}
			
			if (!empty($_POST['im'])) {
				$im = check(cut($_POST['im'], get_option('length_im')));
				$im = mysql_escape_string($im);
			} else {
				$im = '';
			}
			
			if (!empty($_POST['url'])) {
				$url = check(cut($_POST['url'], get_option('length_url')));
				$url = mysql_escape_string($url);
			} else {
				$url = '';
			}
			
			if (!empty($_POST['about'])) {
				$about = check(cut($_POST['about'], get_option('length_about')), true);
				$about = mysql_escape_string($about);
			} else {
				$about = '';
			}
			
			if (!empty($_POST['interests'])) {
				$interests = check(cut($_POST['interests'], get_option('length_interests')), true);
				$interests = mysql_escape_string($interests);
			} else {
				$interests = '';
			}
		}
		
		$sql = 'update ' . USERS_TABLE . ' set 
		user_email = "'. $email . '",
		user_sex = "' . $sex . '",
		user_name = "' . $name . '",
		user_surname = "' . $surname . '",
		user_phone = "' . $phone . '",
		user_im = "' . $im . '",
		user_url = "' . $url . '",
		user_about = "' . $about . '",
		user_interests = "' . $interests . '"
		where user_id = ' . $user_id;
		
		mysql_query($sql);
		
		echo '<p>';
		echo 'Данные профиля ' . (isset($_POST['reset']) ? 'сброшены' : 'изменены') . '<br />' . "\n";
		echo '<a href="profile.php">Посмотреть на изменения</a><br />' . "\n";
		echo '<a href="usercp.php?profile">Вернуться</a>' . "\n";
		echo '</p>' . "\n";
	}
} elseif (isset($_REQUEST['avator'])) {
	/**
	 * Просмотр аватора
	 */
	
	$theme = array (
		'Аватор',
		'Аватор',
		'<a href="usercp.php">Кабинет</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	if (!is_file('wb-content/avators/' . $user_id . '.png')) {
		echo '<p>' . "\n";
		echo 'Аватора нет<br />' . "\n";
		echo '<a href="usercp.php?upload_avator">Выгрузить</a>' . "\n";
		echo '</p>' . "\n";
	} else {
		$config_image = getimagesize('wb-content/avators/' . $user_id . '.png');
		
		if ($config_image) {
			echo '<p>' . "\n";
			echo '<img src="wb-content/avators/' . $user_id . '.png" ' . $config_image[3] . ' alt="Аватор" /><br />' . "\n";
			echo '<a href="usercp.php?delete_avator">Удалить</a>' . "\n";
			echo '</p>' . "\n";
		} else {
			unlink('wb-content/avators/' . $user_id . '.png');
			
			echo '<p>' . "\n";
			echo 'Произошла ошибка. Ваш аватор удален.<br />' . "\n";
			echo '<a href="usercp.php?upload_avator">Выгрузить</a>' . "\n";
			echo '</p>' . "\n";
		}
	}
} elseif (isset($_REQUEST['upload_avator'])) {
	/**
	 * Выгрузка аватора
	 */
	
	$theme = array (
		'Аватор',
		'Выгрузка аватора',
		'<a href="usercp.php">Кабинет</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	if (is_file('wb-content/avators/' . $user_id . '.png')) {
		redirect('usercp.php');
	}
	
	if (isset($_POST['submit'])) {
		if (!empty($_FILES['avator']) && is_uploaded_file($_FILES['avator']['tmp_name'])) {
			/**
			 * Загрузка методом POST
			 */
			$file = file_get_contents($_FILES['avator']['tmp_name']);
			$image = @imagecreatefromstring($file);
		} elseif (!empty($_POST['avator']) && strstr($_POST['avator'], 'file=')) {
			/**
			 * Загрузка через браузер Opera Mini mod SG-DC
			 */
			list(, $file) = explode('file=', $_POST['avator']);
			$file = @base64_decode($file);
			$image = @imagecreatefromstring($file);
		}
		
		if ($image) {
			/**
			 * Параметры изображения
			 */
			$avator_width  = imagesx($image);
			$avator_height = imagesy($image);
			
			/**
 			 * Если расширение изображения больше необходимого
			 * создаем уменьшенную версию аватора
			 */
			if (get_option('avator_width') < $avator_width || get_option('avator_height') < $avator_height) {
				/**
 				 * Определяем уменьшенные размеры, 
				 * пропорциональные размерам оригинального изображения
				 */
				$ratio_width = $avator_width / get_option('avator_width');
				$ratio_height = $avator_height / get_option('avator_height');
				
				if ($ratio_width == $ratio_height) {
					$new_width = get_option('avator_width');
					$new_height = get_option('avator_height');
				} elseif ($ratio_width > $ratio_height) {
					$new_width = get_option('avator_width');
					$new_height = round($avator_height / $ratio_width);
				} else {
					$new_width = round($avator_width / $ratio_height);
					$new_height = get_option('avator_height');
				}
				
				/**
				 * Заменяем идентификатор оригинального изображения $image 
				 * на идентификатор уменьшенного изображения
				 */
				$new = ImageCreateTrueColor($new_width, $new_height);
				imageCopyResized($new, $image, 0, 0, 0, 0, $new_width, $new_height, $avator_width, $avator_height);
				$image =& $new;
			}
			
			/**
			 * СОхраение изображения
			 */
			if (imagePng($image, 'wb-content/avators/' . $user_id . '.png')) {
				chmod('wb-content/avators/' . $user_id . '.png', 0777);
				
				echo '<p>' . "\n";
				echo 'Аватор выгружен<br />' . "\n";
				echo '<a href="usercp.php?avator">Посмотреть</a>' . "\n";
				echo '</p>' . "\n";
			} else {
				echo '<p>' . "\n";
				echo 'Произошла ошибка при сохранении аватора, обратитесь к администратору' . "\n";
				echo '</p>' . "\n";
			}
		} else {
			echo '<p>' . "\n";
			echo 'Аватор не выгружен<br />' . "\n";
			echo 'Вы пытаетесь выгрузить неграфический файл!<br />' . "\n";
			echo '<a href="usercp.php?upload_avator">Вернуться</a>' . "\n";
			echo '</p>' . "\n";
		}
	} else {
		echo '<form enctype="multipart/form-data" action="usercp.php" method="post">' . "\n";
		echo '<input type="hidden" name="upload_avator" />' . "\n";
		echo '<input type="hidden" name="submit" />' . "\n";
		echo '<table ' . get_option('table_attributes') . '>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="title">' . "\n";
		echo 'Выгрузка аватора' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="text">' . "\n";
		
		if (stristr(UA, 'opera mini')) {
			echo '<input type="text" name="avator" size="15" /><br />' . "\n";
			echo '<a href="op:fileselect">Выбрать файл</a>' . "\n";
		} else {
			echo 'Выберите файл:<br />' . "\n";
			echo '<input type="file" name="avator" size="17" />' . "\n";
		}
		
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '<tr>' . "\n";
		echo '<td id="sub">' . "\n";
		echo '<input type="submit" value="Загрузить" />' . "\n";
		echo '</td>' . "\n";
		echo '</tr>' . "\n";
		echo '</table>' . "\n";				
		echo '</form>' . "\n";
	}
}
elseif (isset($_REQUEST['delete_avator'])) {
	/**
	 * Удаление аватора
	 */
	
	$theme = array (
		'Аватор',
		'Удаление аватора',
		'<a href="usercp.php">Кабинет</a><br />' . "\n" .
		'<a href="index.php">На главную</a>'
	);
	
	unlink('wb-content/avators/' . $user_id . '.png');
	
	echo '<p>' . "\n";
	echo 'Аватор удален<br />' . "\n";
	echo '<a href="usercp.php?avator">Вернуться</a>' . "\n";
	echo '</p>' . "\n";
} else {
	$theme = array (
		'Личный кабинет',
		'Личный кабинет',
		'<a href="index.php">На главную</a>'
	);

	echo '<p>' . "\n";
	echo $is_admin ? '<a href="wb-admin/">Админ-панель</a><br />' . "\n" : '';
	
	echo '<a href="privmsgs.php">Приватная почта</a><br />' . "\n";
	echo '<a href="settings.php">Настройки</a><br />' . "\n";
	echo '<a href="profile.php">Профиль</a><br />' . "\n";
	echo '<a href="usercp.php?profile">Изменение профиля</a><br />' . "\n";
	echo '<a href="usercp.php?password">Изменение пароля</a><br />' . "\n";
	echo '<a href="usercp.php?avator">Аватор</a><br />' . "\n";
	echo '<a href="blogs/index.php?user=' . $user_id . '">Ваш блог</a><br />' . "\n";
	echo '<a href="friends.php">Ваши друзья</a><br />' . "\n";
	echo '<a href="wall.php">Ваша стена</a><br />' . "\n";
	echo '<a href="index.php?logout">Выход</a>' . "\n";
	echo '</p>' . "\n";
}

close($theme);
?>