<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0c
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 20:00
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
defined("IN_WBENGINE") or die("Hacking attempt");

/**
 * Версия WB Engine
 */
define("WB_ENGINE_VERSION", "1.0c");

/**
 * Имена таблиц
 */
define("BLOG_ACCESS_TABLE", "blog_access"); // Доступ к модерированию личных блогов
define("BLOG_COMMENTS_TABLE", "blog_comments"); // Комментарии
define("BLOG_POSTS_TABLE", "blog_posts"); // Посты блогов
define("BLOG_TAGS_TABLE", "blog_tags"); // Метки постов

define("BLOGS_ACCESS_TABLE", "blogs_access"); // Доступ групп к модерированию коллективным блогом
define("BLOGS_USER_TABLE", "blogs_user"); // Участие пользователей в коллективных блогах
define("BLOGS_USER_ENTRIES_TABLE", "blogs_user_enries"); // Заявки на участие пользователей в коллективных блогах
define("BLOGS_TABLE", "blogs"); // Коллективные блоги

define("CONFIG_TABLE", "config"); // Конфиг

define("GROUP_USER_TABLE", "group_user"); // Участие пользователя в группу
define("GROUPS_USER_TABLE", "group_user"); // Участие пользователя в группу
define("GROUPS_TABLE", "groups"); // Группы

define("FRIENDS_TABLE", "friends"); // Друзья
define("FRIENDS_ENTRIES_TABLE", "friends_entries"); // Заявки на дружбу
define("PRIVMSGS_IN_TABLE", "privmsgs_in"); // Входящие сообщения
define("PRIVMSGS_OUT_TABLE", "privmsgs_out"); // Исходящие сообщения
define("SESSIONS_TABLE", "sessions"); // Сессии
define("USERS_TABLE", "users"); // Пользователи
define("WALL_POSTS_TABLE", "wall_posts"); // Стена пользователей

/**
 * Типы вступления читателей в блог
 */
define("BLOG_OPEN", "0"); // Открыто
define("BLOG_ENTRY", "1"); // С предмодерацией
define("BLOG_CLOSE", "2"); // Закрыто

/**
 * Просмотр записи блога
 */
define("BLOG_POST_MEMBERS", "0"); // Для участников группы (только коллективный блог)
define("BLOG_POST_FRIENDS", "1"); // Для друзей (только личный блог)
define("BLOG_POST_F_FRIENDS", "2"); // Для друзей и друзей друзей (только личный блог)
define("BLOG_POST_USERS", "3"); // Для всех пользователей

/**
 * Просмотр комментариев к записи блога
 */
define("BLOG_COMMENTS_DISABLE", "0"); // В комментариях не нуждается
define("BLOG_COMMENTS_MEMBERS", "1"); // Для участников группы (только коллективный блог)
define("BLOG_COMMENTS_FRIENDS", "2"); // Для друзей (только личный блог)
define("BLOG_COMMENTS_F_FRIENDS", "3"); // Для друзей и друзей друзей (только личный блог)
define("BLOG_COMMENTS_USERS", "4"); // Для всех пользователей

/**
 * Добавление комментария к записи блога
 */
define("BLOG_COMMENT_DISABLE", "0"); // Отключить комментирование, отображать только существующие комментарии
define("BLOG_COMMENT_MEMBERS", "1"); // Для участников группы (только коллективный блог)
define("BLOG_COMMENT_FRIENDS", "2"); // Для друзей (только личный блог)
define("BLOG_COMMENT_F_FRIENDS", "3"); // Для друзей и друзей друзей (только личный блог)
define("BLOG_COMMENT_USERS", "4"); // Для всех пользователей

/**
 * Просмотр списка друзей пользователя
 */
define("FRIENDS_ME", "0"); // Только для пользователя
define("FRIENDS_FRIENDS", "1"); // Для друзей
define("FRIENDS_F_FRIENDS", "2"); // Для друзей и друзей друзей
define("FRIENDS_USERS", "3"); // Для всех пользователей

/**
 * Предложения пользователю дрыжбы
 */
define("FRIENDSHIP_DISABLE", "0"); // Отключены
define("FRIENDSHIP_USERS_WITH_ENTRY", "1"); // С заявкой
define("FRIENDSHIP_USERS", "2"); // Непосредственное добавление

/**
 * Отправка приватных сообщений пользоватлю
 */
define("PRIVMSGS_FRIENDS", "0"); // Только для друзей
define("PRIVMSGS_F_FRIENDS", "1"); // Для друзей и друзей друзей
define("PRIVMSGS_USERS", "2"); // Для всех пользователей

/**
 * Просмотр сообщений на стене пользователя
 */
define("WALL_ME", "0"); // Только для пользователя
define("WALL_FRIENDS", "1"); // Друзья
define("WALL_F_FRIENDS", "2"); // Друзья и друзья друзей
define("WALL_USERS", "3"); // Все пользователи

/**
 * Добавление сообщения на стене прользователя
 */
define("WALL_POSTING_ME", "0"); // Только для пользователя
define("WALL_POSTING_FRIENDS", "1"); // Друзья
define("WALL_POSTING_F_FRIENDS", "2"); // Друзья и друзья друзей
define("WALL_POSTING_USERS", "3"); // Все пользователи

/**
 * Статус пользователя
 */
define("USER_OFFLINE", "0"); // Офлайн
define("USER_ONLINE", "1"); // Онлайн
define("USER_HIDE", "2"); // Скрыт
?>