<?php
/**
 * project:
 * WB Engine
 *
 * version:
 * 1.0
 *
 * authors: 
 * Artem Egorov aka zick
 *
 * last edit:
 * 25/07/2009 02:15
 *
 * GNU General Public License, version 2:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */
defined('IN_WBENGINE') or die('Hacking attempt');

// Отсылка header`ов
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Cache-Control: no-cache, must-revalidate');
header('Pragma: no-cache');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . 'GMT');
header('Content-type: ' . (stristr(UA, 'msie') ? 'text/html' : 'application/xhtml+xml') . '; charset=UTF-8');

$online = online_statistics();

echo '<?xml version="1.0" encoding="utf-8" ?>';
?>
<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru">
<head>
<title><?php echo get_option('home_title') ?> / <?php echo isset($theme[0]) ? $theme[0] : '' /* title страницы */ ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="copyright" content="wbengine" />
<meta name="keywords" content="<?php echo get_option('meta_keywords') /* meta keywords */ ?>" />
<meta name="description" content="<?php echo get_option('meta_description')/* meta description */ ?>" />
<link rel="shortcut icon" href="<?php echo HOME ?>wb-includes/themes/twilight/images/favicon.ico" />
<link rel="stylesheet" href="<?php echo HOME ?>wb-includes/themes/twilight/css/main.css" type="text/css" />
</head>
<body>

<div id="topbar">

<!-- Панель навигации -->
<a href="<?php echo HOME ?>index.php" alt="На главную"><div id="nav1"><img src="<?php echo HOME ?>/wb-includes/themes/twilight/images/home.gif" alt="Home" /></div></a>
<a href="<?php echo HOME ?>users.php"><div id="nav1">Люди</div></a>
<a href="<?php echo HOME ?>groups.php"><div id="nav1">Группы</div></a>
<a href="<?php echo HOME ?>blogs/index.php"><div id="nav1">Записи</div></a>
<a href="<?php echo HOME ?>blogs/blogs.php"><div id="nav1">Блоги</div></a>


<?php if ($is_logged): ?>
<!-- Личное меню -->
<a href="<?php echo HOME ?>index.php?logout"><div id="nav2">Выход</div></a>
<a href="<?php echo HOME ?>usercp.php"><div id="nav2">Кабинет</div></a>
<a href="<?php echo HOME ?>settings.php"><div id="nav2">Настройки</div></a>
<a href="<?php echo HOME ?>friends.php"><div id="nav2">Друзья</div></a>
<a href="<?php echo HOME ?>privmsgs.php"><div id="nav2">Личные сообщения</div></a>
<?php if ($is_admin): ?>
<a href="<?php echo HOME ?>wb-admin/"><div id="nav2">Админ-панель</div></a>
<?php endif; ?>
<?php else: ?>
<div id="login">
<!-- Форма авторизации -->
<form action="<?php echo HOME ?>/login.php" method="post">
<span id="login_text">
Логин: <input id="login_input" type="text" name="l" /> 
Пароль: <input id="login_input" type="password" name="p" /> 
<input id="login_submit" type="submit" value="Вход" />
</span>
</form>
</div>
<?php endif; ?>
</div>

<div id="content">
<?php if(isset($theme[1])): ?>
<div id="site"><?php echo $theme[1] ?></div>
<?php endif; ?>


<?php if ($is_logged && $user_data['user_unread_privmsgs']): ?>
<div class="nav" style="text-align: left;">
<a href="<?php echo HOME ?>/privmsgs.php?action=inbox">Новые сообщения: <?php echo $user_data['user_unread_privmsgs'] ?></a>
</div>
<?php endif; ?>

<?php echo $buffer /* Отображение буфера */ ?>

<?php if (isset($theme[2])) { /* Отображение ссылок для навигации (foot) */ ?>
<p><?php echo $theme[2] ?></p>
<?php } ?>
</div>

<div id="footbar">
<a href="<?php echo HOME ?>users.php?online" id="nav3">Онлайн <?php echo  $online['u'] ?> / <?php echo $online['a'] ?></a><br />
Время генерации страницы: <?php echo gtime() ?> сек.<br />
<?php if (PAGE == 'index.php'): /* Не удаляйте, пожалуйста ;) */ ?>
Управляется с помощью WB Engine <?php echo WB_ENGINE_VERSION ?>
<?php endif; ?>
</div>
</body>
</html>